#!/usr/bin/python3


from tkinter import *
from PIL import Image, ImageTk
import subprocess
from pprint import pprint
import threading
import os
import sys
import urllib3.request
import argparse
import time
import afrikalan.tkinter
import textwrap

glob_dialog_bg="#F8F8F8"
glob_dialog_padx=24
glob_dialog_pady=10
glob_infoframe_bg="#FFFFFF"
glob_button_bg="#E0E0E0" #was: #D4D4D4


def wrap(txt, wrplen):
  return("\n".join(textwrap.wrap(txt, wrplen)))

class Interface_waitCnx(Frame):
  
  def __init__(self, fenetre, targetDesc):
    self.fenetre=fenetre
    self.fond=glob_dialog_bg
    self.targetDesc=targetDesc
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    
    self.pack(fill=BOTH)
    
    self.colonnes=Frame(self, bg=self.fond)
    self.colonnes.pack()
    
    
    self.txtFrameW=460
    self.txtFrame=Frame(self.colonnes, bg=self.fond, width=self.txtFrameW)
    #self.txtFrame.pack_propagate(False)
    self.txtFrame.pack(side=LEFT, fill=BOTH, ipadx=10)
    
    self.titre = Label(self.txtFrame, text="Veuillez connecter le boiter\n Afrikalan à internet pour continuer.", bg=self.fond, font='Helvetica 20 bold', pady=12)
    self.titre.pack()
    
    self.message = Label(self.txtFrame, text=wrap("Vous allez ouvrir « "+self.targetDesc+" ».", 54), pady=12, bg=self.fond, font='Helvetica 14', justify="left")
    self.message.pack(anchor="w")
    self.message2 = Label(self.txtFrame, text=wrap("Cette application a besoin d'une connexion internet pour fonctionner. Elle démarrera dès que vous aurez connecté le boiter Afrikalan à Internet.", 54), pady=12, bg=self.fond, font='Helvetica 14', justify="left")
    self.message2.pack(anchor="w")
    
    self.linkGuide=afrikalan.tkinter.Link(self.txtFrame, text=wrap("Cliquez ici pour voir comment connecter Afrikalan à internet avec un téléphone.", 54), bg=self.fond, cursor="hand1", fg="#599de3", font='Helvetica 14', pady=20, command=self.evtAffGuide)
    self.linkGuide.pack(anchor="w")

    #self.message3 = Label(self.txtFrame, text=wrap("Cette fenêtre se fermera et "+self.targetDesc+" démarrera automatiquement dès qu'Afrikalan sera connecté.", 60), pady=2, bg=self.fond, justify="left", fg="#777777", font='Helvetica 12 italic')
    #self.message3.pack(anchor="w")

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self.txtFrame, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    self.bouton_quitter.pack(anchor="e")  


    self.hsepColonnes=Frame(self.colonnes, width=16, bg=self.fond) #H-Separator
    self.hsepColonnes.pack(side=LEFT) 
    
    self.imgUSBPlug=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/photos/brancheTel-300.jpg")
    self.lblImgUSBPlug=Label(self.colonnes, image=self.imgUSBPlug, pady=16)
    self.lblImgUSBPlug.pack(side=RIGHT)
    
  
  def evtAffGuide(self):
    subprocess.Popen(["afrikalanAffMan.py", "/usr/share/doc/afrikalan/guides/connexion/connexion.xml", "--staytop", "y"])
    
  def evtConnect(self):
    self.txtFrame.destroy()
    self.hsepColonnes.destroy()

    self.connectOkFrame=Frame(self.colonnes, bg=self.fond, width=self.txtFrameW, padx=32) # reste vite jursqu'à la connexion
    self.connectOkFrame.pack(side=LEFT, fill=BOTH)


    self.lblConnectOK=Label(self.connectOkFrame, bg=self.fond, text=wrap("Félicitations, vous êtes connecté à internet!", 40)+"\n\n"+wrap("L'application « "+self.targetDesc+" » est en train de démarrer...",40), font="Helvetica 20", fg="#2eaf2b", justify="left")
    self.lblConnectOK.pack(ipady=10)
    Frame(self.connectOkFrame, height=32, bg=self.fond).pack() #V-Separator

    self.bouton_quitterOK = Button(self.connectOkFrame, text="", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    self.bouton_quitterOK.pack(anchor="e")  

    self.tickConnectCountDown=9
    self.tickConnectQuit()
  
  def tickConnectQuit(self):
    self.tickConnectCountDown-=1
    self.bouton_quitterOK.configure(text="Fermer ce message ("+str(self.tickConnectCountDown)+")")
    
    if self.tickConnectCountDown==0:
      self.quit()
    else:
      self.after(1000, self.tickConnectQuit)


class Thread_testCnx(threading.Thread):
  def __init__(self, evtFinished):
    threading.Thread.__init__(self)
    self.evtFinished=evtFinished
    self.connectDetected=False
    
    timeout = urllib3.Timeout(connect=2.0, read=5.0)
    self.http = urllib3.PoolManager(timeout=timeout, retries=False)

  def run(self):
    try:
      print("debut Req")
      response = self.http.request("GET", "http://www.afrikalan.org/test-cnx/")
      content = response.data.decode()
      print("fin Req")
      print(content)
      if content[:12]=="AFRIKALAN_OK":
        self.connectDetected=True
    except:
      pass
    
    self.evtFinished(self.connectDetected)
    
  def getConnectDetected(self):
    return(self.connectDetected)



class Thread_waitCnx(threading.Thread):
  def __init__(self, evtConnection):
    threading.Thread.__init__(self)
    self.evtConnection=evtConnection
    self.evtConnectionEnvoye=False
                                    
    self.compteOuvert=0
    self.compteFerme=0

    
  def run(self):
    self.active=True
    while self.active:
      time.sleep(2)
      thread_testCnx=Thread_testCnx(self.sousThreadFini)
      thread_testCnx.start()
      self.compteOuvert+=1
      print("Ouvertures cnx test: "+str(self.compteOuvert)+"  ---- fermetures cnx test: "+str(self.compteFerme))
      
      
  def finish(self):
    self.active=False
    
  def sousThreadFini(self, boolConnectionDetectee):
    self.compteFerme+=1
    if (boolConnectionDetectee and not self.evtConnectionEnvoye):
      self.evtConnectionEnvoye=True
      self.evtConnection()
    



##
## 
##
def parseArgs():
  argparser=argparse.ArgumentParser(description="Attend la connexion pour lancer l'application et affichant un message indiquant à l'utilisateur qu'une connexion est attendue et proposant de l'aide pour établir la connexion")
  argparser.add_argument("--cmdDesc", help="Identification textuelle de l'application qui sera lancée (pour la mentionner sur le message affiché à l'utilisateur", default='une application')
  argparser.add_argument('commande', nargs=argparse.REMAINDER, help="commande à lancer")
  return(argparser.parse_args())


class RunApp:
  
  def __init__(self, args):
    self.args=args
  
    self.root=Tk()
    self.root.attributes('-topmost', True)
    self.root.title('En attente de connexion...')
  
    self.ifWaitCnx=Interface_waitCnx(self.root, targetDesc=self.args.cmdDesc)
    thread_waitCnx=Thread_waitCnx(self.evtCnxOk)
    thread_waitCnx.start()
    afrikalan.tkinter.center(self.root)
    self.ifWaitCnx.mainloop()
    print("exited ML ifWaitCnx")
    self.root.destroy()
    print("finishing connexions")
    thread_waitCnx.finish()
      

  def runTargetCmd(self):
    self.root.attributes('-topmost', False)
    subprocess.Popen(self.args.commande)
    subprocess.Popen(["killall", "afrikalanAffMan.py"])


  def evtCnxOk(self):
    self.runTargetCmd()
    self.ifWaitCnx.evtConnect()
    self.ifWaitCnx.update_idletasks() #else still wait until mouse mooved...



args=parseArgs()
RunApp(args)
