#!/bin/sh

exec > /tmp/logBoot
exec 2>&1

. /etc/afrikalan.conf

if [ "$afrikalan_type_materiel" = "pc" ]; then
        afrikalanBootPc.sh
        exit
fi


cat /proc/cmdline | grep -o "root=[^ ]*"
if cat /proc/cmdline | grep -o "root=[^ ]*" | grep nand; then
export afrikalanSupport="nand"
fi

if cat /proc/cmdline | grep -o "root=[^ ]*" | grep mmcblk; then
export afrikalanSupport="sd"
fi

mntp="/rw"


umount $afrikalan_partRW
mount $afrikalan_partRW $mntp -ofmask=000,dmask=000
if [ $? -ne 0 ]; then
/sbin/mkfs.vfat $afrikalan_partRW
mount $afrikalan_partRW $mntp -ofmask=000,dmask=000
fi

mkdir -p $mntp/Documents/tuxPaint
mount --bind $mntp/Documents /home/pi/Documents
mount --bind $mntp/Documents/tuxPaint /home/pi/.tuxpaint/saved

echo "#BOOT" >> /rw/log.txt

#Gestion du son USB pour raspberry pi Zero

if [ "$afrikalan_gestionSonUsb" = 1 ]; then
	echo "ok" >/tmp/tmp
	if lsmod | grep snd_usb_audio >/dev/null; then 
		/sbin/rmmod snd_bcm2835 >> /tmp/log_file 2>> /tmp/err_file
		echo "fdait" >/tmp/fait
	fi
fi

#Execution du script de maintenance
if [ -e /dev/sda1 ]; then
	mount /dev/sda1 /mnt
	if [ -e /mnt/afrikalanMaintenance.sh ]; then
		sh /mnt/afrikalanMaintenance.sh
	fi
	umount /mnt
fi


#
# Montage des squashfs
#
ls -1 /squashfs/ | xargs -n1 -i bash -c "mount /squashfs/{} \$(echo '{}' | sed 's/[.]squashfs\$//g; s/@/\//g')"


#
# Gestion du réseau
#
if [ "$afrikalan_mode_serveur" = "on" ] || ([ "$afrikalan_mode_serveur" = "auto" ] && [ ! -e /var/lib/afrikalan/XLance.lock ]) ; then
  afrikalanDemarreServeur.sh
fi
#else
  #client DHCP si besoin (ne plus utiliser?, le port ethernet est monitoré? le demaons de monitoring gère il les usb hot-pluggable?)
  #if /sbin/ifconfig eth0; then
  #  afrikalanDhclient.sh eth0&
  #fi
#fi

if [ "$afrikalan_mode_serveur_wifi" = "client" ]; then
  echo "mode client wlan"
  echo "wpa_supplicant -i wlan0 -c /usr/share/afrikalan/wpa_supplicant.afkl.conf" | at now
fi

/etc/init.d/ssh start

if [ -n "$afrikalan_keymap" ]; then
loadkeys $afrikalan_keymap
fi


echo "fiman jeman lobo ba seydou" > /var/lib/afrikalan/bootFini.flag
