#!/bin/bash

if [ "$1" != "runFromAt" ]; then
 echo $0 runFromAt $@ | at now
 exit 0
fi

mntp="/rw"
. /etc/afrikalan.conf

export PATH="$PATH:/bin:/usr/bin:/sbin:/usr/sbin"

#
# Test si premier boot depuis installation
#
if  cat /etc/passwd | grep "^[^:]*:[^:]*:1000:" > /dev/null; then
#l'utilisateur 1000 n'existe pas si on est en liveCD. (utilisateur "ubuntu"=999)
	/bin/cat /etc/passwd | grep "^$afrikalan_utilisateur:" > /dev/null
	if [ -$? -ne 0 ]; then
		echo "premier boot: creation de l'utilisateur $afrikalan_utilisateur"
		afrikalanDeploieHomePc.sh
	fi
fi

mkdir -p "$mntp/afrikalanHome/Documents/tuxPaint"
chmod -R 755 "$mntp/afrikalanHome"
chown -R $afrikalan_utilisateur "$mntp/afrikalanHome"


mkdir -p /tmp/homeAfrikalan
mount unionfs-fuse#/tmp/homeAfrikalan=rw:/ro/homeAfrikalan=ro /home/$afrikalan_utilisateur -tfuse -ocow,allow_other,nonempty
chown $afrikalan_utilisateur /home/$afrikalan_utilisateur

mkdir -p /home/$afrikalan_utilisateur/Documents
mount --bind "$mntp/afrikalanHome"/Documents /home/$afrikalan_utilisateur/Documents
mkdir -p /home/$afrikalan_utilisateur/.tuxpaint/saved
mount --bind "$mntp/afrikalanHome"/Documents/tuxPaint /home/$afrikalan_utilisateur/.tuxpaint/saved

rm /var/lib/afrikalan/fond_hasard.jpg
idxHazard=$(echo $(md5sum /rw/log.txt | sed "s/[^0-9]//g") "%" $(find /usr/share/wallpapersBL/ -type f | grep . -c) +1 | bc)
ln -s $(find /usr/share/wallpapersBL/ -type f | shuf | tail -n$idxHazard | head -n1) /var/lib/afrikalan/fond_hasard.jpg

#
# Montage des squashfs
#
ls -1 /squashfs/ | xargs -n1 -i bash -c "mount /squashfs/{} \$(echo '{}' | sed 's/[.]squashfs\$//g; s/@/\//g')"


echo "#BOOT" >> /rw/log.txt


