#!/bin/bash

version=$1
rep="afrikalan-ecosysteme-"$version"-all"
homeBase="/home/pi"

rm -rvf $rep
mkdir $rep

echo "*********************"
echo " copie des fichiers *"
echo "*********************"

mkdir -p $rep/DEBIAN
mkdir -p $rep/usr/bin
mkdir -p $rep/usr/share/doc
mkdir -p $rep/etc/cron.d
mkdir -p $rep/etc/init.d
mkdir -p $rep/etc/dnsmasq.d
mkdir -p $rep/lib/systemd/system
mkdir -p $rep/etc/udev/rules.d
mkdir -p $rep/usr/share/pixmaps
mkdir -p $rep/usr/share/icons
mkdir -p $rep/usr/share/menu
mkdir -p $rep/usr/share/applications
mkdir -p $rep/var/lib/afrikalan
mkdir -p $rep/usr/lib/python3/dist-packages


#preparation du squellette etc dans /usr/share/afrikalan
rm -rvf /usr/share/afrikalan/skelEtc/* # on purge les vieux fichiers...
#cp -rv /etc/afrikalan* /usr/share/afrikalan/skelEtc/
(cd /etc; find . -iregex "./afrikalan.*"  -not -iregex "./afrikalan/.*[.d]/.*" -not -iregex "./afrikalanSkelHomePc.tar.bz2" -exec cp --parents -v -t /usr/share/afrikalan/skelEtc "{}"  "+" ) #tous les fichier de config afrikalan sauf les .d définis par afrikalan (traités à la ligne suivante)
(cd /etc/afrikalan; find . -regex ".*[.]d/afrikalan.*" -not -regex ".*[.]d/afrikalan-www-.*" -exec cp --parents -v -t /usr/share/afrikalan/skelEtc/afrikalan "{}"  "+" ) #tous les morceaux de .d lié à afrikalan (à l'exeption des fichiers créés par les modules


#binaires et ressources
find /usr/bin/ -regex "/usr/bin/afrikalan.*" -not -regex "/usr/bin/afrikalan-www-.*" -exec cp -pv {} $rep/usr/bin \;
#cp -v $homeBase/bin/* $rep/usr/bin
cp -rv /usr/share/doc/afrikalan $rep/usr/share/doc
cp -rv /usr/share/afrikalan $rep/usr/share
cp -rv /usr/lib/python3/dist-packages/afrikalan $rep/usr/lib/python3/dist-packages
cp -v /etc/cron.d/afrikalan $rep/etc/cron.d
find /etc/init.d/ -regex "/etc/init.d/afrikalan.*" -not -regex "/etc/init.d/afrikalan-www-.*" -exec cp -v {} $rep/etc/init.d \;
find /lib/systemd/system/ -regex "/lib/systemd/system/afrikalan.*" -not -regex "/lib/systemd/system/afrikalan-www-.*" -exec cp -v {} $rep/lib/systemd/system \;
cp -v /etc/dnsmasq.d/afrikalan* $rep/etc/dnsmasq.d
cp -v /etc/udev/rules.d/10-afrikalan.rules $rep/etc/udev/rules.d
cp -v /usr/share/pixmaps/afrikalan* $rep/usr/share/pixmaps
cp -v /usr/share/menu/afrikalan* $rep/usr/share/menu
cp -v /usr/share/applications/afrikalan* $rep/usr/share/applications
cp -v /usr/share/icons/afrikalan* $rep/usr/share/icons

mkdir -p $rep/etc/ifplugd/action.d
cp -v /etc/ifplugd/action.d/afrikalan* $rep/etc/ifplugd/action.d

#fichier de configuration utilisateur
mkdir -p $rep/usr/share/afrikalan/skelHome
cp -rv $homeBase/Desktop $rep/usr/share/afrikalan/skelHome
mkdir -p $rep/usr/share/afrikalan/skelHome/.config
cp -rv "$homeBase/.config/lxpanel" $rep/usr/share/afrikalan/skelHome/.config
cp -rv "$homeBase/.config/midori" $rep/usr/share/afrikalan/skelHome/.config
cp -rv "$homeBase/.config/openbox" $rep/usr/share/afrikalan/skelHome/.config
cp -rv "$homeBase/.config/pcmanfm" $rep/usr/share/afrikalan/skelHome/.config
cp -rv "$homeBase/.config/autostart" $rep/usr/share/afrikalan/skelHome/.config

#
# ecriture des fichiers système
#

cat <<END > $rep/DEBIAN/control
Package: afrikalan-ecosysteme
Provides: malinux-ecosysteme
Conflicts: malinux-ecosysteme
Replaces: malinux-ecosysteme
Version: $version
Architecture: all
Essential: no
Section: education
Priority: optional
Depends: jclic, unionfs-fuse, bc, fbi, gksu, wmctrl, xaw3dg, xdotool, lsof, xprintidle, python-tk, imagemagick, xinput, numlockx, xserver-xephyr, xwit, at, python3-tk, python3-pil, python3-pil.imagetk, python3-lxml, sqlite3, bluez, obexftp, python3-xlib, python3-pdfkit, python3-psutil, exfat-fuse, exfat-utils, hfsprogs, ntfs-3g, x11vnc, tightvncserver
Maintainer: Julien Marin <julien.marin@afrikalan.org>
Homepage: http://www.afrikalan.org
Installed-Size: $(du -s $rep | grep -o "^[0-9]*")
Description: Ecosystème logiciel permetant le fonctionnement d'Afrikalan et dérivés
 Ce paquet contient les scripts, images, parametres de configuration et autres éléments nécéssaires
 au fonctionnement des ordinateurs éducatifs Afrikalan (sur télé, tablette, bidon, ect...).
 .
 L'écosystème Afrikalan vise à adapter les logiciels éducatifs aux ordinateurs éducatifs Afrikalan: 
 affichage sur petit écran (télé ou tablette), fonctionnement en lecture seule, simplification de 
 l'interface, ouverture des applis éducatives en plein écran, clavier ou souris virtuels, etc...

END


cat <<END > $rep/DEBIAN/postinst
#!/bin/sh
set -e
if [ "\$1" = "configure" ] && [ -x "" ]; then
	update-menus
fi
  cp -n /usr/share/afrikalan/skelEtc/afrikalan.conf /etc/afrikalan.conf
  cp -n /usr/share/afrikalan/skelEtc/afrikalanOverscan.conf /etc/afrikalanOverscan.conf
  mkdir -p /etc/afrikalan
  cp -nr /usr/share/afrikalan/skelEtc/afrikalan/* /etc/afrikalan

  if ps -p 1 | grep systemd >/dev/null; then
    if [ -e /lib/systemd/system/lightdm.service ]; then systemctl disable lightdm; fi
    systemctl enable afrikalanBootM 
    #systemctl enable afrikalanSplashM #ne marche pas + bug demarrage
    #systemctl enable afrikalanStartXM #a developper 
    systemctl disable x11-common
    systemctl enable afrikalanStartX
    systemctl enable afrikalanSplash
  else
    if [ -e /etc/init.d/lightdm ]; then update-rc.d lightdm disable; fi
    update-rc.d afrikalanBoot defaults
    update-rc.d afrikalanBoot enable
    update-rc.d afrikalanSplash defaults
    update-rc.d afrikalanSplash enable
    update-rc.d afrikalanStartX defaults
    update-rc.d afrikalanStartX enable
    update-rc.d x11-common disable
  fi

  mkdir -p /ro /rw /squashfs

  exit 0

END

cat <<END > $rep/DEBIAN/prerm
#!/bin/sh
set -e
# Automatically added by dh_installmenu
if [ -x "" ]; then update-menus ; fi
# End automatically added section

if [ "\$1" = "purge" ]; then
	rm /etc/afrikalan.conf
	rm /etc/afrikalanOverscan.conf
fi

  if ps -p 1 | grep systemd >/dev/null; then
    systemctl disable afrikalanBoot
    systemctl disable afrikalanSplash
    systemctl disable afrikalanStartX
  else
    update-rc.d afrikalanBoot disable
    update-rc.d afrikalanSplash disable
    update-rc.d afrikalanStartX disable
  fi

END

chmod -R 755 $rep/DEBIAN


dpkg -b $rep
