#!/bin/bash -v

if [ "$1" == "progression" ]; then
	tailleOrig=$2

	
	tailleDest=$(df | grep "/mnt$" | head -n1 | sed "s/^[^ ]* *[^ ]* *//g; s/ \+.*$//g")
fi

offset=0

cat /proc/cmdline | grep -o "root=[^ ]*" | grep mmcblk
if [ $? -ne 0 ]; then
	--title="Erreur" --button=gtk-close  -text "La duplication ne fonctionne que si le système s'execute lui-meme depuis une carte SD..."
fi

tailleSysHR=$(df -h | grep "/$" | head -n1 | sed "s/^[^ ]* *[^ ]* *//g; s/ \+.*$//g")
tailleSys=$(df | grep "/$" | head -n1 | sed "s/^[^ ]* *[^ ]* *//g; s/ \+.*$//g")


if $(yad --title "Dupliquer Afrikalan" --text "Cet outil vous permet de créer une copie du système Afrikalan sur une autre carte SD. En insérant cette carte SD dans un autre appareil, vous créerez un nouvel exemplaire d'Afrikalan.\n\nAvant de commencer:\nSi jamais vous aviez inséré une clef USB dans l'appareil, retirez-là. Le système de copie pourrait la confondre avec la carte SD et copier le système Afrikalan dessus (ce qui l'éffacerai)\n\nLa taille du système est de $tailleSysHR Une carte de capacité égale ou supérieure est nécéssaire.\nCette carte sera formatée et les données de cette carte seront remplacées par le système Afrikalan. Si vous avez des fichiers sur cette carte, copiez-les ailleurs pour ne pas les perdre!\n\nLorsque vous cliquerez sur 'valider' ce programme va attendre que vous branchiez un adaptateur USB contenant une carte SD dans l'appareil." --width 500); then


#
# ETAPE 1: Effacement...
#

yad --text "Etape 1: Veuillez brancher un adaptateur USB contenant une carte SD vers laquelle Afrikalan sera copié. \n\nCette carte sera d'abord effacée afin de pouvoir accueillir Afrikalan, puis vous serez invité à la retirer." --title="En attente d'une carte SD" --button=gtk-cancel&
pidYadAttente=$!

devCarte=""
while [ -z "$devCarte" ]; do
devCarte=$(sudo fdisk -l | grep -o "Disk /dev[^:]*:" | sed "s/^Disk //g; s/:$//g" | grep -v /dev/mmcblk0)
sleep 0.5s
if ! kill -0 $pidYadAttente; then
#annulation
exit
fi
done

kill $pidYadAttente

dd if=/dev/zero of=${devCarte} bs=1M count=10
sync

yad --text "Veuillez à présent retirer de l'appareil l'adaptateur USB contenant la carte SD. Cela permet de s'assurer que plus aucune autre application n'utilise la carte lors de la copie du système (prochaine étape)" --title="En attente d'une carte SD" --button=gtk-cancel&
pidYadAttente=$!

while ! [ -z "$devCarte" ]; do
devCarte=$(sudo fdisk -l | grep -o "Disk /dev[^:]*:" | sed "s/^Disk //g; s/:$//g" | grep -v /dev/mmcblk0)
sleep 0.5s
if ! kill -0 $pidYadAttente; then
#annulation
exit
fi
done

kill $pidYadAttente

#
# ETAPE 2: Formatage...
#

yad --text "Etape 2: Veuillez brancher à nouveau l'adaptateur USB contenant la carte SD vers laquelle Afrikalan sera copié. \n\nLa copie commencera dès que vous aurez insérer de nouveau la carte." --title="En attente d'une carte SD" --button=gtk-cancel&
pidYadAttente=$!

devCarte=""
while [ -z "$devCarte" ]; do
devCarte=$(sudo fdisk -l | grep -o "Disk /dev[^:]*:" | sed "s/^Disk //g; s/:$//g" | grep -v /dev/mmcblk0)

if ! kill -0 $pidYadAttente; then
#annulation
exit
fi
done

kill $pidYadAttente



if ( echo $devCarte | grep mmcblk ); then
	p="p"
else
	p=""
fi


sudo mount /dev/mmcblk0p1 -oremount,ro
sudo mount /dev/mmcblk0p2 -oremount,ro
sudo mount /dev/mmcblk0p3 -oremount,ro

#
#
# FORMAT / SPL / U-BOOT / PARTITION
#
#

yad --text "Etape 2: Formatage, préparation de la carte,\net copie de la partition d'amorçage..." --title="Préparation de la copie" --no-buttons&
pidYadAttente=$!

sleep 4s
wmctrl -c "amovible"
umount $devCarte"*"
sleep 2s
umount $devCarte"*"

dd if=/dev/zero of=${devCarte} bs=1M count=1
dd if=/dev/mmcblk0 of=${devCarte} bs=1M count=1


cat <<EOT | sfdisk --force --in-order -uM ${devCarte}
$(echo 8 + $offset | bc),16,c
,$(echo $(sfdisk -s ${devCarte}) "/ 1024 - 25 - 50 - $offset" | bc),L
,,L
EOT

#Au cas où l'OS remonte la carte tout seul...
sleep 4s
umount $devCarte"*"
sleep 4s
umount $devCarte"*"

dd if=/dev/zero of=${devCarte}${p}1 bs=1M count=1
dd if=/dev/zero of=${devCarte}${p}2 bs=1M count=1
mkfs.vfat ${devCarte}${p}1
mkfs.ext4 ${devCarte}${p}2
tune2fs -r25 ${devCarte}${p}2



#
#
# BOOT
#
#

mount ${devCarte}${p}1 /mnt/
cd /boot
tar -c . | tar -x --directory /mnt
umount /mnt

kill $pidYadAttente 

#
#
# ROOT 
#
#

mount ${devCarte}${p}2 /mnt/
tar --one-file-system --exclude="/tmp/*" --exclude="/boot/*" --exclude="/media/*" --exclude="/sys/*" --exclude="/mnt/*" --exclude="/proc/*" --exclude="/run/*" --exclude="/rw/*"  --exclude="/var/*" -c / | tar -xv --warning=no-timestamp --directory /mnt&
pidtar=$!
(while kill -0 $pidtar; do echo $(echo $(df | grep "/mnt$" | head -n1 | sed "s/^[^ ]* *[^ ]* *//g; s/ \+.*$//g") "*" 100 / $tailleSys |bc ); sleep 10s; done |  yad --progress --title="Copie en cours" --text="Etape 3: Le système est en cours de copie. Merci de patienter.\n\nEtant donné la quantité importante de données à copier,\ncette opération va prendre un peu de temps..." --text-align=center --no-buttons )&
pidYadProgr=$!

while kill -0 $pidtar; do sleep 20s; echo "----------"; done

echo "fin A"
kill $pidYadProgr
mkdir /mnt/tmp /mnt/boot /mnt/media /mnt/mnt /mnt/proc /mnt/run /mnt/rw /mnt/var /mnt/sys
umount /mnt

echo "fin B"

sync

#killall yad ne pas faire! tue le process pere et plante la copie
yad --title="C'est fini." --button=gtk-close --text "C'est fini. Si tout s'est bien passé, vous pouvez retirer la carte SD et l'insérer dans un Raspberry Pi pour fabriquer un nouvel exemplaire d'Afrikalan."

sudo mount /dev/mmcblk0p3 -oremount,rw


fi

