#!/bin/sh

app_ouverte=0

listeProc=$(ps -w -w -u $(whoami))


#
# Apps utilisant midori (vikidia et pepit)
#
echo $listeProc | grep midori
if echo $listeProc | grep midori >/dev/null; then
	if echo $listeProc | grep kiwix-serve >/dev/null; then
		#vikidia est lancé
		if wmctrl -l | grep "Accueil" >/dev/null; then
			killall yad
		else
			midori -e Back "http://127.0.0.1:8080/vikidia_fr_all/?"
		fi
	else
		#pepit est lancé
		if wmctrl -l | grep "Accueil"  >/dev/null; then
			killall yad
		else
			midori -e Back "http://127.0.0.1:8080/vikidia_fr_all/?"
		fi
		
		midori -e Back "file:///usr/share/www-local/www.pepit.be/index.html"
	fi
	app_ouverte=1
fi

#
# Tuxtype, Tuxpaint
#
if echo $listeProc | grep "\(tuxtype\|tuxmath\)" >/dev/null; then
	xdotool key Escape
	app_ouverte=1
fi

#
# jclic
#
if echo $listeProc | grep "java" >/dev/null; then
	pidJava=$(ps -w -w -u $(whoami) | grep java | grep -o "^[ 0123456789]*" | grep -o "[0-9]*")
	echo "pj="$pidJava
	
	#Menu principal?
	if wmctrl -l | grep "\[menu\]"; then
		killall yad;
	else
		listeFich=$(lsof -Fn -p $pidJava | grep ".jclic[.]zip" | sort | uniq)
		if echo $listeFich | grep lecture-bmbm; then
			jclic /usr/share/JClic/lecture-bmbm/menu.jclic.zip
		fi
		if echo $listeFich | grep lecture-fr; then
			jclic /usr/share/JClic/lecture-fr/menu.jclic.zip
		fi
		if echo $listeFich | grep activites-jclic-fr; then
			jclic /usr/share/JClic/activites-jclic-fr/menu.jclic.zip
		fi
	fi
	app_ouverte=1
fi


if echo $listeProc | grep "tuxpaint" >/dev/null; then
	killall -9 tuxpaint
	app_ouverte=1
fi

if echo $listeProc | grep "gcompris" >/dev/null; then
	killall gcompris
	app_ouverte=1
fi

if [ $app_ouverte -eq 0 ]; then
	wmctrl -l | grep -v "\(panel\|pcmanfm\)" | sed "s/0x[0-9a-f]* *[0-9*] *[0-9a-zA-Z]* *//g" | xargs -n1 -i wmctrl -c "{}"
fi
