#!/bin/bash


mkdir -p /tmp/mntnanda
mkdir -p /tmp/mntsd1
mkdir -p /tmp/mntnandb
mkdir -p /tmp/mntsd2

if [ "$1" == "" ]; then
echo "Usage: $0 chemin_vers_tarball"
exit
fi


if [ "$1" == "--skip-backup" ]
then
	if [ ! -e /rw/nand.mbr.img ] | [ ! -e /rw/nanda.original.tar.bz2 ]; then 
		echo "impossible de continuer sans sauvegarde"
		exit
	fi
	shift
else
	if [ -e /rw/nand.mbr.img ] | [ -e /rw/nanda.original.tar.bz2 ]; then
		echo "une sauvegarde existe déjà, si c'est celle d'un appareil, suprimez /rw/nand.mbr.img et /rw/nanda.original.tar.bz2"
		echo "si c'est celle de cet appreil, utilisez la commande: $0 --skip-backup chemin_vers_tarball"
		exit
	fi
	echo "création de copies de sauvegarde"
	dd if=/dev/nand of=/rw/nand.mbr.img bs=1M count=1
	bzip2 /rw/nand.mbr.img
	mount /dev/nanda /tmp/mntnanda
	dirorig=$(pwd)
	cd /tmp/mntnanda
	tar -cjvf /rw/nanda.original.tar.bz2 *
	cd "$dirorig"
	umount /tmp/mntnanda
	
	echo "vérifez qu'il n'y ai pas eu d'erreur et pressez entrée pour continuer"
	read

fi
	

echo "affichage de la table des partitions"
nand-part /dev/nand

echo "*****************************************"
txtParta=$(nand-part /dev/nand | grep "^partition *1:" | head -n1)
debParta=$(echo $txtParta | grep -o "partition start *= *[0-9]*" | grep -o "[0-9]*")
tailleParta=$(echo $txtParta | grep -o "partition size *= *[0-9]*" | grep -o "[0-9]*")

tailleNand=$(fdisk -l /dev/nand | grep -o "total [0-9]* sectors" | grep -o "[0-9]*")
taillePartb=7650000
taillePartc=$(echo "$tailleNand - $debParta - $tailleParta - $taillePartb" | bc)

cmdNandPart="nand-part /dev/nand $debParta 'boot $tailleParta' 'root $taillePartb' 'data $taillePartc'"
echo "la commande de partionnement suivante va être lancée"
echo $cmdNandPart
echo .
echo "vérifez qu'il n'y ai pas eu d'erreur et pressez entrée pour continuer"
echo "(l'écriture sur la nand s'enclanche apres cette étape)"
read

echo .
echo .
echo "** Partitionement **"
eval $cmdNandPart

echo .
echo .
echo "** Reformatage partition boot **"
mkfs.msdos -F16 /dev/nanda
mount /dev/nanda /tmp/mntnanda
tar --directory /tmp/mntnanda -xjvf /rw/nanda.original.tar.bz2
mount /dev/mmcblk0p1 /tmp/mntsd1
cp /tmp/mntsd1/u-boot-nand.bin /tmp/mntnanda/linux/u-boot.bin -v
cp /tmp/mntsd1/uImage /tmp/mntnanda/linux/uImage -v

umount /dev/mmcblk0p1
umount /dev/nanda

echo .
echo .
echo "** Formatage partition système **"
mkfs.ext4 /dev/nandb

echo .
echo .
echo "** Formatage partition données **"
mkfs.msdos -F16 /dev/nandc


echo .
echo .
echo "pressez entrée pour installer le rootFs"
read
read

mount /dev/nandb /tmp/mntnandb
tar --directory /tmp/mntnandb -xjvf "$1"

echo .
echo .
echo "** Copie des modules **"
rm -rvf /tmp/mntnandb/lib/modules
cp -rv /lib/modules /tmp/mntnandb/lib

echo .
echo .
echo "** Configuration rootFs **"

echo afrikalanTablette > /tmp/mntnandb/etc/hostname

cat <<END > /tmp/mntnandb/etc/fstab
/dev/nanda    /boot	vfat	defaults		0	0 
/dev/nandb    /		ext4	defaults,noatime,ro	0	0 
tmpfs	/tmp		tmpfs	defaults,size=15M	0	0

unionfs-fuse#/tmp=rw:/ro/var=ro		/var 	fuse	cow,allow_other,nonempty
unionfs-fuse#/tmp=rw:/ro/home=ro	/home	fuse	cow,allow_other
unionfs-fuse#/tmp=rw:/ro/media=ro	/media	fuse	cow,allow_other

END

echo .
echo .
echo "** C'est fini **"
