#!/bin/bash

. /etc/afrikalan.conf

if [ -f /sys/class/thermal/thermal_zone0/temp ]; then
  cpuTemp=$(( $(cat /sys/class/thermal/thermal_zone0/temp) / 1000 ))
else
  cpuTemp=""
fi

if [ -f /tmp/AfrikalanInfosUtilisateur.txt ]; then
  infosUtil="[util="$(cat /tmp/AfrikalanInfosUtilisateur.txt)"]"
else
  infosUtil=""
fi


# cpuTemp0=$(cat /sys/class/thermal/thermal_zone0/temp)
# cpuTemp1=$(($cpuTemp0/1000))
# cpuTemp2=$(($cpuTemp0/100))
# cpuTempM=$(($cpuTemp2 % $cpuTemp1))
# cpuFreq=$(cat /sys/devices/system/cpu/cpu0/cpufreq/scaling_cur_freq)

inact=$(su $afrikalan_utilisateur -c "bash -c 'export DISPLAY=:0; xprintidle'")
limite_log=$afrikalan_inact_stopLog"000" #multiplie par 1000
if [ -n "$inact" ] && [ $inact -gt $limite_log ]; then
	echo "#INACTIVITE#" $infosUtil $(date) $(uptime) "(temp="$cpuTemp")"
	exit
fi


# echo "#DEBUTENTREE#" CPU"="$cpuTemp1"."$cpuTempM"'C/"$cpuFreq"KHz; GPU="$(/opt/vc/bin/vcgencmd measure_temp | sed 's/temp=//g') "/" $(uptime)
 echo "#DEBUTENTREE#" $infosUtil $(date) $(uptime) "(temp="$cpuTemp")"



procs=$(ps -A --format comm | grep "^\(midori\|tuxtype\|tuxmath\|florence\|kiwix\|gcompris\|tuxpaint\|java\|quartz_browser\)$" | sort | uniq)
echo "$procs"

#détail pepit
if echo $procs | grep midori >/dev/null; then
ps -A -f | grep gnash | grep -o "file://[^ ]*" | sort | uniq
fi


#détail web
if echo $procs | grep quartz_browser >/dev/null; then
	#if [ -e /tmp/site.last ]; then
	#	cat /tmp/site.last
	#fi
	url=$(cat /home/$afrikalan_utilisateur/.lastVisitedUrl)
	[[ "$url" =~ 8080/wikipedia_fr ]]		&& echo wikipedia
	[[ "$url" =~ 8080/vikidia_fr ]] 		&& echo vikidia
	[[ "$url" =~ lecteurs/livres/reader.php ]] 	&& echo livre_ecrit
	[[ "$url" =~ lecteurs/videos/player.php ]] 	&& echo video
	[[ "$url" =~ lecteurs/livresaudio/player.php ]] && echo livre_audio
	[[ "$url" =~ modules/lecture/lecture_fr ]] 	&& echo lecture-fr
	[[ "$url" =~ modules/lecture/lecture_fl ]] 	&& echo lecture-fl
	[[ "$url" =~ modules/lecture/lecture_bm ]] 	&& echo lecture-bm
	[[ "$url" =~ modules/clickinfoadoml ]] 		&& echo clicinfoado
fi


#détail jclic
if echo $procs | grep java >/dev/null; then
pid=$(ps -A | grep java | tail -n1 | grep -o "^[ 0123456789]*" | grep -o "[0-9]*")
if [ -n "$pid" ]; then
lsof -Fn -p $pid | grep ".jclic[.]zip" | sort | uniq
fi
fi


