#!/usr/bin/python3

import afrikalan.transfer.handler
import afrikalan.tkinter

import tkinter

from lxml import etree


import os
import pprint
import subprocess



modulesPath='/var/www-afrikalan/modules'

#
# Pilotage
#

class TransferLib:
  def __init__(self, tranferMode):
    self.transferMode=tranferMode
    self.arInfosItems=[]
    self.hydrateTransfers()
    self.sort()

  def hydrateTransfers(self):
    if os.path.isdir(modulesPath):
      scanModules=os.listdir(modulesPath)
      for module in scanModules:
        handlersPath=modulesPath+'/'+module+'/transfer-visible'
        if os.path.isdir(handlersPath):
          scanHandlers=os.listdir(handlersPath)
          for handler in scanHandlers:
            handlerPath=handlersPath+'/'+handler
            if os.path.isfile(handlerPath):
              self.processHandler(handlerPath)

  def processHandler(self, handlerPath):
    print("Processing "+handlerPath+"...")
    transferHandler=afrikalan.transfer.handler.Handler(handlerPath, ["--from-library"])
        
    availMode=transferHandler.availableTransferModes()
    if availMode[self.transferMode]=='0':
      return(False) #don't process if the transfer mode we need insn't enabled
    
    if not transferHandler.checkOk():
      return(False) #if transfer tell to checko for some file, check them
    
    self.arInfosItems.append({'value': handlerPath, 'title': transferHandler.appName(), 'description': transferHandler.appDecr(), 'icon': transferHandler.appIconAbs(), 'order': transferHandler.order()})
    
  def sort(self):
    self.arInfosItems.sort(key=lambda transfer: transfer['order'])
    
#
# Main
#
tranferLib=TransferLib(tranferMode='usb')

root=tkinter.Tk()
root.attributes('-topmost', True)
root.title('Logithèque Afrikalan')
ifChoixApp = afrikalan.tkinter.Interface_Liste(root, tranferLib.arInfosItems, txtMessage="Veuillez choisir ce que vous\nsouhaitez transférer sur la clé.")
afrikalan.tkinter.center(root)
ifChoixApp.mainloop()
ifChoixApp.destroy()

if ifChoixApp.choice is not False:
  subprocess.Popen(["afrikalanTransfert.py", ifChoixApp.choice, "--media", "USB", "--from", "library"])

