#!/usr/bin/python3

import afrikalan.manual
import afrikalan.tkinter

import tkinter

from lxml import etree


import os
import pprint
import subprocess




manRoot='/usr/share/doc/afrikalan/guides'

#
# Pilotage
#

class TransferLib:
  def __init__(self):
    self.arInfosItems=[]
    self.hydrateMans()
    self.hydrateBuiltin()
    self.sort()

  def hydrateBuiltin(self):
    self.arInfosItems.append({'value': "#INFOAFKL", 'title': "À propos d'Afrikalan", 'description': 'Informations sur le projet Afrikalan et sur la provenance des logiciels inclus', 'icon': '/usr/share/afrikalan/images/iconeApropos-65.png', 'order': 10})
    self.arInfosItems.append({'value': "#ASSDIST", 'title': "Assistance à distance", 'description': 'Partager ce qui est affiché sur votre écran lors d\'une aide par téléphone.', 'icon': '/usr/share/afrikalan/images/assistance-65.png', 'order': 950})
    

  def hydrateMans(self):
    if os.path.isdir(manRoot):
      scanManRoot=os.listdir(manRoot)
      for manDir in scanManRoot:
        manDirPath=manRoot+'/'+manDir
        if os.path.isdir(manDirPath):
          scanMans=os.listdir(manDirPath)
          for manFile in scanMans:
            manFilePath=manDirPath+'/'+manFile
            baseName, ext=os.path.splitext(manFile)
            if ext.lower()==".xml" and os.path.isfile(manFilePath):
              self.processHandler(manFilePath)

  def processHandler(self, manFilePath):
    print("Processing "+manFilePath+"...")
    
    content=afrikalan.manual.ContentHandler(manFilePath, callfrom='')
        
    itemInfos=content.getMenuItemInfos()
    
    if itemInfos.get("visible")==1:
      self.arInfosItems.append({'value': manFilePath, 'title': 'Guide: '+content.getTitle(), 'description': content.getDescription(), 'icon': itemInfos.get("icon"), 'order': itemInfos.get("order")})
    
  def sort(self):
    self.arInfosItems.sort(key=lambda transfer: transfer['order'])
    
#
# Main
#
tranferLib=TransferLib()

root=tkinter.Tk()
root.attributes('-topmost', True)
root.title('Aide et outils Afrikalan')
ifChoix = afrikalan.tkinter.Interface_Liste(root, tranferLib.arInfosItems, txtMessage="Bonjour, comment puis-je vous aider ?")
afrikalan.tkinter.center(root)
ifChoix.mainloop()
ifChoix.destroy()

if ifChoix.choice=="#INFOAFKL":
  subprocess.Popen(["afrikalanInfos.sh"])
elif ifChoix.choice=="#ASSDIST":
  subprocess.Popen(["afrikalanAttendCnx.py", "--cmdDesc", "Assistance à distance", "afrikalanAssistance.py"])
elif ifChoix.choice is not False:
  subprocess.Popen(["afrikalanAffMan.py", ifChoix.choice, "--from", "helpMenu"])

