#!/usr/bin/python3

import tkinter
import afrikalan.tkinter
from tkinter import messagebox

import pprint
import subprocess

import psutil
import pprint
import sys


def genChoices(runningProcs):
  choices=[]
  if runningProcs.midori:
    choices.append({'value': 'transfertPage', 'title': 'Transférer sur la clé la page que vous lisez', 'icon': '/usr/share/afrikalan/images/transfert-page_65.png', 'description': 'Cela transferera sur la clé la page actuellement affichée à l\'écran, afin que vous puissiez l\'emmener avec vous, et la consulter ou l\'imprimer depuis un autre ordinateur.'})
  choices.append({'value': 'logitheque', 'title': 'Transférer une application sur la clé', 'icon': '/usr/share/afrikalan/images/icone_transfert_65.png', 'description': 'Permet de tranférer les jeux éducatifs et encyclopédies se trouvant sur cet appareil vers la clé, afin que vous puissiez les utiliser sur d\'autres ordinateurs.'})
  choices.append({'value': 'open', 'title': 'Afficher le contenu de la clé', 'icon': '/usr/share/afrikalan/images/ouvre-clef_65.png', 'description': 'Le contenu s\'affichera, vous pourrez accéder aux documents qui s\'y trouvent.'})
  choices.append({'value': 'eject', 'title': 'Ejecter la clé', 'icon': '/usr/share/afrikalan/images/usb-eject_65.png', 'description': ''})
  return(choices)

class ParseRunningProcs:
  def __init__(self):
    self.transfert=False
    self.midori=False
    self.parseProcs()
    
  def parseProcs(self):
    for p in psutil.process_iter():
      arCmd=p.cmdline()
      #pprint.pprint(arCmd)
      if len(arCmd)>=1 and arCmd[0]=='midori':
        self.midori=True
      if len(arCmd)>=2 and arCmd[1]=="/usr/bin/afrikalanTransfert.py":
        self.transfert=True
       

if len(sys.argv)<2:
  print("usage: "+sys.argv[0]+" rep_mnt")
  sys.exit(10)
  
repMnt=sys.argv[1]

runningProcs=ParseRunningProcs()
if runningProcs.transfert:
  sys.exit(0) #USB Key inserted beacause of tranfer, don't show this menu

root=tkinter.Tk()
root.attributes('-topmost', True)
root.title('Clé USB')
ifChoixAction = afrikalan.tkinter.Interface_Liste(root, genChoices(runningProcs), txtMessage="Vous avez inséré une clé USB,\nVous pouvez faire les choix suivants:", scrollFrame=False)
afrikalan.tkinter.center(root)
ifChoixAction.mainloop()
ifChoixAction.destroy()



if ifChoixAction.choice=='transfertPage':
  subprocess.Popen(["afrikalanTransfert.py", 'afrikalanTransfertPage.py', "--media", "USB", "--from", "usbMenu"])
elif ifChoixAction.choice=='logitheque':
  subprocess.Popen(["afrikalanLogitheque.py"])
elif ifChoixAction.choice=='open':
  subprocess.Popen(["pcmanfm", repMnt])
elif ifChoixAction.choice=='eject':
  subprocess.Popen(["afrikalanMassStorEject"])
  messagebox.showinfo(message="Vous pouvez maintenant retirer la clé USB en toute sécurité.")

