#!/bin/bash

killall xvkbd

#regle le bug empechant de lancer yad en root (saturation de TMP)
#rm -rvf /tmp/pi/*

. /etc/afrikalan.conf

cmdyad="yad --title=\"Outils de maintenance\" --image /usr/share/afrikalan/images/imageDlgInfos.png --form --columns 1 --field=\"Régler la sortie son\":BTN \"$0 son\" --field=\"Changer le nom de l'exemplaire\":BTN \"$0 nom\" --field=\"Choisir le fond d'écran\":BTN \"$0 choixFond\" --field=\"Positionner l'image sur l'écran\":BTN \"$0 overscan\" --field=\"Modifier afrikalan.conf\":BTN \"$0 editeConfig\" --field=\"Ouvrir un terminal\":BTN \"$0 terminal\" --field=\"Passer en mode écriture\":BTN \"$0 modeEcriture\" --field=\"Installer Afrikalan sur une autre carte SD\":BTN \"$0 duplik\"" 

case "$afrikalan_type_materiel" in
	pi)
		. /usr/bin/afrikalanOutilsPi.sh
		cmdyad="$cmdyad --field \"Gestion de l'overclock\":BTN \"$0 overclock\""
	;;
	sunxi)
		. /usr/bin/afrikalanOutilsSunxi.sh
		cmdyad="$cmdyad --field=\"Modifier type affichage\":BTN \"$0 sortieImage\""
	;;
	*)
		yad --image error --title erreur --button gtk-close --text "Le type de matériel n'est pas correctement défini dans afrikalan.conf"
		exit 1
esac


function editeSon {
	mount / -oremount,rw
	sudo -u $afrikalan_utilisateur pavucontrol
  	yad --title="redémarrer" --text "Le système a besoin de redémarrer." --button gtk-ok
  	yad --title="redémarrage" --text "veuillez patienter...." --text-align=center --no-buttons --borders=50 &
	sleep 8s
 	rm /ro/home/$afrikalan_utilisateur/.config/pulse/*
	sudo -u $afrikalan_utilisateur cp /home/$afrikalan_utilisateur/.config/pulse/*-device-volumes* /home/$afrikalan_utilisateur/.config/pulse/*-default-* /ro/home/$afrikalan_utilisateur/.config/pulse
	mount / -oremount,ro
	reboot
}

function editeConfig {
	mount / -oremount,rw
	afrikalanRunClavier.sh leafpad /etc/afrikalan.conf
	mount / -oremount,ro
	if $( yad --title="redémarrer?" --text "vos modification ont été enregistrées.\nVoulez-vous redémarrer maintenant?"); then
		reboot
	fi
}

function terminal {
	afrikalanRunClavier.sh lxterminal
}

function modeEcriture {
	if $( yad --title="Activer mode RW?" --text "Toute modification faites en mode écriture sera permanente\nFaites attention à ne pas rendre le système inutilisable\n\n.\nVoulez vous activer le mode écriture?"); then
		mount / -oremount,rw
		mount --bind /ro/var /var
		mount --bind /ro/home /home
		yad --image=dialog-information --title "mode écriture activé" --text "Le mode écriture est actif.\n\n Veuillez éteindre l'appareil dès que vous aurez fait vos modifications au système\n\nL'appareil repassera en lecture seule au prochain démarage." --button=ok
	else
		exit 1
	fi
}

function choixFond {
	mount / -oremount,rw
	mount --bind /ro/home /home
	su $afrikalan_utilisateur -c "pcmanfm --desktop-pref"
	yad --title="redémarrer" --text "Veuillez cliquez sur \"valider\" après avoir fait vos modifications\n Le système a besoin de redémarrer." --button gtk-ok
	umount /home
	mount / -oremount,ro
	reboot
}


case $1 in
  son)
    editeSon
  ;;
	nom)
		afrikalanRunClavier.sh afrikalanChangeNomHote.sh
	;;
	choixFond)
		choixFond
	;;
	duplik)
		afrikalanDuplik.sh
	;;
	sortieImage)
		AffChoixSortieImage
	;;
	overclock)
		ouvre_config_overclock
	;;
	overscan)
		ouvre_config_overscan
	;;
	editeConfig)
		editeConfig
	;;
	terminal)
		terminal
	;;
	modeEcriture)
		modeEcriture
	;;
	*)
		#killall lxpanel
		eval $cmdyad
		#yad --title="Outils de maintenance" --image /usr/share/afrikalan/images/imageDlgInfos.png --form --columns 1 --field="Changer le nom de l'exemplaire":BTN "$0 nom" --field="Positioner l'image sur l'écran":BTN "$0 overscan" --field "Gestion de l'overclock":BTN "$0 overclock" --field="Modifier afrikalan.conf":BTN "$0 editeConfig" --field="Ouvrir un terminal":BTN "$0 terminal" --field="Passer en mode écriture":BTN "$0 modeEcriture" --field "Installer Afrikalan sur une autre carte SD":BTN "$0 duplik" --button="gtk-close" 
		#lxpanel
	;;
esac
