#!/usr/bin/python3

from tkinter import font, Frame, Tk, Button
from PIL import Image, ImageTk

import Xlib
import Xlib.display


import subprocess
from pprint import pprint
import threading
import time
import fcntl
import os
import re
import sys
#import psutil
import afrikalan.config
import afrikalan.xwin



#
# Interface elements
#

class Interface_dockButton__button:
  def __init__(self, root, bg, text, image, imagemini, action):
    self.root=root
    self.bg=bg
    self.text=text
    self.image=image
    self.imagemini=imagemini
    self.action=action
    self.widget = Button(self.root, text="", image=self.imagemini, command=self.action, bg=self.bg, activebackground="#FFFFFF", compound="left", pady=0, borderwidth=0) #set pady=0 then use ipad because else 
    self.fontNormal=font.Font(self.widget, self.widget.cget("font"))
    self.fontActive=font.Font(self.widget, self.widget.cget("font"))
    self.fontActive.configure(weight="bold", size=11)
    
    
    self.widget.bind("<Enter>", self.evtMouseEnter)
    self.widget.bind("<Leave>", self.evtMouseLeave)


  def showText(self):
    self.widget.configure(text=self.text, width=100)
    
  def hideText(self):
    self.widget.configure(text="", width=False)
    
  def evtMouseEnter(self, event):
    self.widget.configure(font=self.fontActive, image=self.image)
    
  def evtMouseLeave(self, event):
    self.widget.configure(font=self.fontNormal, image=self.imagemini)





class interface_dockButton(Frame):
  
  def __init__(self, root):
    self.root=root
    self.bg="#E0E0E0"
    self.objButtons=[]
    
    Frame.__init__(self, self.root, padx=2, pady=2, bg=self.bg)
    
    self.bind("<Enter>", self.evtMouseEnter)
    self.bind("<Leave>", self.evtMouseLeave)
  
  
  def addButton(self, flavour, action):
    if flavour=="quit":
      text="Quitter"
      imgmini=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_fermer_16.png")
      img=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_fermer.png")
      row=14
    elif flavour=="back":
      text="Retour"
      imgmini=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_retour_16.png")
      img=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_retour.png")
      row=11
    elif flavour=="menu":
      text="Menu"
      #TODO: image
      imgmini=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_retour_16.png")
      img=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_retour.png")
      row=11
    elif flavour=="zoomIn":
      text="Agrandir"
      imgmini=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_zoomIn_16.png")
      img=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_zoomIn.png")
      row=1
    elif flavour=="zoomOut":
      text="Réduire"
      imgmini=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_zoomOut_16.png")
      img=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_zoomOut.png")
      row=2
    elif flavour=="help":
      text="Aide"
      #TODO: image
      imgmini=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_aide_16.png")
      img=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_aide_24.png")
      row=12
    elif flavour=="transfert":
      text="Transfert"
      #TODO: image
      imgmini=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_transfert_16.png")
      img=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/icone_transfert.png")
      row=13
    else:
      raise NameError("type de boutton inconnu")
    
    btn=Interface_dockButton__button(self, self.bg, text, img, imgmini, action)
    btn.widget.grid(row=row, column=1, ipadx=5, ipady=10)
    self.objButtons.append(btn)
      
  def addSep(self):
    Frame(self, height=32, bg=self.bg).grid(row=9)
  
  def display(self, position="left", popHover=True):
    self.popHover=popHover
    self.position=position
    self.pack()
    
    if not self.popHover:
      self.expand()
      
    self.positionate()
    
      
  def positionate(self):
    self.root.update_idletasks() #so we can read the width next...
    if self.position=="right":
      x=self.root.winfo_screenwidth()-self.root.winfo_width()
    else:
      x=0
      
    y=self.root.winfo_screenheight()-self.root.winfo_height()
    
    self.root.geometry("+"+str(x)+"+"+str(y))
    
      
  def expand(self):
    for button in self.objButtons:
      button.showText()
    self.positionate()

  def compact(self):
    for button in self.objButtons:
      button.hideText()
    self.positionate()
  
    
  def evtMouseEnter(self, event):
    if self.popHover:
      self.expand()
    
  def evtMouseLeave(self, event):
    if self.popHover:
      self.compact()
  


#
# Threads
#

class ThreadRunCommand(threading.Thread):
  def __init__(self, arComm, evtFinish):
    threading.Thread.__init__(self)
    self.arComm=arComm
    self.evtFinish=evtFinish

  #not used...
  def killall(self):
    try:
      #self.proc.kill()
      #parent = psutil.Process(self.proc.pid)
      #for child in parent.children(recursive=True):  # or parent.children() for recursive=False
      #    child.kill()
      #parent.kill()
      os.kill(self.proc.pid, 9)
      print("procs killed")
    except AttributeError:
      pass
    
  def run(self):
    self.proc=subprocess.Popen(self.arComm, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    print ("pid="+str(self.proc.pid))
    ret, errs = self.proc.communicate()
    self.evtFinish()
    

#wait for specified window to appear, then catch it's coordinates...
class ThreadManageWin(threading.Thread):
  def __init__(self, titlePart, margins={}):
    threading.Thread.__init__(self)
    self.titlePart=titlePart
    self.maxScanDepth=2 #Finaly all we need seems to be toplevel
    self.winId=False
    self.boolSearchActive=True
    self.evtFound=False
    
    self.margins={'top': 0, 'left': 0, 'bottom': 0, 'right': 0}
    self.margins.update(margins) #merge default margins with supplied ones...
    
    self.display = Xlib.display.Display()
    self.getScreenDims()
    
    self.winscanner=afrikalan.xwin.Scanner()
    self.winscanner.partSearch=self.titlePart
    self.winscanner.maxScanWinDepth=2

  def stop_search(self):
    self.boolSearchActive=False
    
  def setEvtFound(self, evtFound):
    self.evtFound=evtFound
  
  def run(self):
    while self.winId==False and self.boolSearchActive:
      if self.winscanner.scanWins():
        self.winId=self.winscanner.foundWinId
        if self.evtFound is not False: 
          self.evtFound()
      time.sleep(0.5)
          
  def getScreenDims(self):
    screen = self.display.screen()
    self.screenWidth=screen["width_in_pixels"]
    self.screenHeight=screen["height_in_pixels"]
    
  def enlarge(self):
    print ("will enlarge ["+str(self.winId)+"]")
    win=self.display.create_resource_object('window', self.winId)
    time.sleep(0.5) #Jclic elarge may fail else...
    
    #Undecorate
    _MOTIF_WM_HINTS = self.display.intern_atom("_MOTIF_WM_HINTS")
    win.change_property(_MOTIF_WM_HINTS, _MOTIF_WM_HINTS, 32, [0x2, 0x0, 0x0, 0x0, 0x0]) #"0x2, 0x0, 0x1, 0x0, 0x0"] to redecorate
    
    w=self.screenWidth-self.margins.get("left")-self.margins.get("right")
    h=self.screenHeight-self.margins.get("top")-self.margins.get("bottom")
    win.configure(x=self.margins.get('left'), y=self.margins.get("top"), width=w, height=h)
    win.get_geometry() #it is mandatory to read some data for the windows for the change to be effective (dont ask me why...)
    
  def hide(self):
    win=self.display.create_resource_object('window', self.winId)
    win.unmap()
    win.get_geometry()

  def show(self):
    win=self.display.create_resource_object('window', self.winId)
    win.map()
    win.get_geometry()

  def closeWin(self):
    if self.winId is not False:
      try:
        win=self.display.create_resource_object('window', self.winId)
        win.destroy()
        win.get_geometry() #it is mandatory to read some data for the windows for the change to be effective (dont ask me why...)
        self.winId=False
      except:
        pass


#
# Pilotage
#

#genère et fourni les données relative à l'appli lancée
class ConfigAppli:
  def __init__(self, arCommandToExec):
    self.cmd=' '.join(arCommandToExec)
    self.defaultConf()
    self.appConf()
    
  def defaultConf(self):
    self.marginTop=0;
    self.marginBottom=0;
    self.marginLeft=0;
    self.marginRight=0;
    self.winTitlePart="########"
    self.arCommandBack=False
    self.handlerTransfert=False
    self.manualFile=False
    self.dockPosition="right"
    self.arExitCmd=False
    self.arCommandZoomIn=False
    self.arCommandZoomOut=False
    
  
  def appConf(self):
    
    #JCLIC
    if self.cmd=="lecture-fr":
      self.winTitlePart="JClic"
      self.marginTop=-21
      self.marginBottom=-42
      self.arCommandBack=["jclic", "/usr/share/JClic/lecture-fr/menu.jclic.zip"]
      self.arExitCmd=["killall", "java"]
      self.handlerTransfert="/var/www-afrikalan/modules/telechargementsLogEducBestof/transfer-visible/lecture-fr.xml"
      self.manualFile='/usr/share/doc/afrikalan/guides/lecture/lecture.xml'
    elif self.cmd=="lecture-bmbm":
      self.winTitlePart="JClic"
      self.marginTop=-21
      self.marginBottom=-42
      self.arCommandBack=["jclic", "/usr/share/JClic/lecture-bmbm/menu.jclic.zip"]
      self.arExitCmd=["killall", "java"]
      self.handlerTransfert="/var/www-afrikalan/modules/telechargementsLogEducBestof/transfer-visible/lecture-bmbm.xml"
      self.manualFile='/usr/share/doc/afrikalan/guides/lecture/lecture.xml'
    elif self.cmd[:12]=="lecture-menu":
      self.winTitlePart="JClic"
      self.marginTop=-21
      self.marginBottom=-42
      #self.arCommandBack=["jclic", "/usr/share/JClic/menulecture.jclic.zip"]
      self.arCommandBack=self.cmd.split()
      self.arExitCmd=["killall", "java"]
      self.handlerTransfert="/var/www-afrikalan/modules/telechargementsLogEducBestof/transfer-private/lecture-select.sh"
      self.manualFile='/usr/share/doc/afrikalan/guides/lecture/lecture.xml'
    elif re.match(r".*activites-jclic-fr", self.cmd):
      self.winTitlePart="JClic"
      self.marginTop=-21
      self.marginBottom=-21
      self.arCommandBack=["jclic", "/usr/share/JClic/activites-jclic-fr/menu.jclic.zip"]
      self.arExitCmd=["killall", "java"]
      self.manualFile='/usr/share/doc/afrikalan/guides/jclic/jclic.xml'
      self.handlerTransfert="/var/www-afrikalan/modules/telechargementsLogEducBestof/transfer-private/act-jclic.xml"
    #Pepit
    elif re.match(r".*[pP]epit.be.*", self.cmd):
      self.marginBottom=-26
      self.winTitlePart="PEPIT des exercices"
      self.arCommandBack=["midori", "-e", "Back"]
      self.marginTop=int(afklConf.get("afrikalan_decalage_midori", "0"))*-1   
      self.arExitCmd=["killall", "midori"]
      self.handlerTransfert="/var/www-afrikalan/modules/telechargementsLogEducBestof/transfer-visible/pepit-be.xml"
      self.manualFile='/usr/share/doc/afrikalan/guides/pepit/pepit.xml'
    elif re.match(r".*[qQ]uartz.*", self.cmd):
      self.winTitlePart="Quartz Browser"
      self.marginTop=-31 
      self.marginBottom=0
      self.arCommandBack=["xdotool", "search", "Quartz Browser", "key", "CTRL+BackSpace"]
      self.arCommandZoomIn=["xdotool", "search", "Quartz Browser", "key", "CTRL+plus"]
      self.arCommandZoomOut=["xdotool", "search", "Quartz Browser", "key", "CTRL+minus"]
      self.arExitCmd=["killall", "quartz_browser"]


      
      
    #Encyclopedias and others ressources
    elif re.match(r"afrikalanWifipedia.sh", self.cmd) or re.match(r".*afrikalanWikipedia.sh", self.cmd) or re.match(r".*afrikalanGutenberg.sh", self.cmd) or re.match(r".*afrikalanVikidia.sh", self.cmd):
      #self.marginBottom=-26
      self.winTitlePart="Quartz Browser"
      self.marginTop=-31 
      self.marginBottom=0
      self.handlerTransfert="afrikalanTransfertPage.py"
      self.arCommandBack=["xdotool", "search", "Quartz Browser", "key", "CTRL+BackSpace"]
      self.arCommandZoomIn=["xdotool", "search", "Quartz Browser", "key", "CTRL+plus"]
      self.arCommandZoomOut=["xdotool", "search", "Quartz Browser", "key", "CTRL+minus"]
      self.manualFile='/usr/share/doc/afrikalan/guides/encyclopedies/encyclopedies.xml'
      self.arExitCmd=["killall", "quartz_browser"]
      
    elif re.match(r".*midori.*", self.cmd):
      #self.marginBottom=-26
      self.winTitlePart="Accueil"
      self.arCommandBack=["midori", "-e", "Back"]
      self.marginTop=int(afklConf.get("afrikalan_decalage_midori", "0"))*-1
      self.handlerTransfert="afrikalanTransfertPage.py"
      self.arCommandZoomIn=["midori", "-e", "ZoomIn"]
      self.arCommandZoomOut=["midori", "-e", "ZoomOut"]
      self.manualFile='/usr/share/doc/afrikalan/guides/encyclopedies/encyclopedies.xml'
    
      
  def checkTransferAvailable(self):
    if self.handlerTransfert is not False and afklConf.get("afrikalan_activer_transfer", "off")=="on":
      #transfer enabled in config and available for this app, let's check if needed files are here...
      f, ext=os.path.splitext(self.handlerTransfert)
      if self.handlerTransfert[0]=="/" or ext==".xml":
        if os.path.isfile(self.handlerTransfert):
          return(True)
      else:
        return(True) #if the handler is runnable and doesn't have absolute path, we assume it's here. this may be changed later if needed
    return(False) #not available by default




class AfrikalanRunPlein:
  def __init__(self, arCommandToExec):
    self.arCommandToExec=arCommandToExec
    self.configAppli=ConfigAppli(arCommandToExec)
    
    self.transfert_tsLastClick=0
    self.man_tsLastClick=0
    
    self.desktop_winName="pcmanfm"
    if afklConf.get("afrikalan_type_materiel", "pi")=="pc":
      self.desktop_winName="Bureau"
    
    
    
  def start(self):
    self.runThreadsManageWin()
    self.prepIface()
    self.run_app()
    
  def prepIface(self):
    root.overrideredirect(True) #disable some stuff, including borders :-)
    self.ifDock=interface_dockButton(root)
    if not boolCmdOptKiosk:
      self.ifDock.addButton("quit", self.evt_quit)
    if self.configAppli.arCommandBack is not False:
      self.ifDock.addButton("back", self.evt_back)
    if self.configAppli.arCommandZoomIn is not False and self.configAppli.arCommandZoomOut is not False:
      self.ifDock.addButton("zoomIn", self.evt_zoomIn)
      self.ifDock.addButton("zoomOut", self.evt_zoomOut)
      self.ifDock.addSep()
    if self.configAppli.manualFile is not False:
      self.ifDock.addButton("help", self.evt_affMan)
    if self.configAppli.checkTransferAvailable():
      self.ifDock.addButton("transfert", self.evt_transfert)
    self.ifDock.display(position=self.configAppli.dockPosition)

    
  def run_app(self):
    self.threadCommand=ThreadRunCommand(arCommandToExec, self.evt_command_finished)
    self.threadCommand.start()

  def evt_back(self):
    #subprocess.run(arCommandBack)
    subprocess.Popen(self.configAppli.arCommandBack)

  def evt_command_finished(self):
    self.evt_quit()

  def evt_zoomIn(self):
    
    subprocess.Popen(self.configAppli.arCommandZoomIn)
    
  def evt_zoomOut(self):
    subprocess.Popen(self.configAppli.arCommandZoomOut)


  def evt_affMan(self):
    if time.time()-self.man_tsLastClick>2:
      subprocess.Popen(["afrikalanAffMan.py", self.configAppli.manualFile, "--from", "dock"])
      self.man_tsLastClick=time.time()
      
  def evt_transfert(self):
    if time.time()-self.transfert_tsLastClick>2:
      subprocess.Popen(["afrikalanTransfert.py", self.configAppli.handlerTransfert, "--from", "dock"])
      self.transfert_tsLastClick=time.time()

  def finishApp(self):
    #self.threadCommand.killall()
    if self.configAppli.arExitCmd is not False:
      subprocess.run(self.configAppli.arExitCmd)
    else:
      self.tmw_app.closeWin()


  def evt_quit(self):
    #on arrete tout...
    self.finishApp()
    self.tmw_app.stop_search()
    self.ifDock.quit()
    try:
      self.ifDock.update() #in some situations, if not giving hand to tk, app won't quit
    except:
      pass
    if (afklConf.get("afrikalan_desktop_mode", "normal")!="kiosque"):
      self.tmw_panel.show()
      self.tmw_desktop.show()

  def runThreadsManageWin(self):
    if (afklConf.get("afrikalan_desktop_mode", "normal")!="kiosque"):
      self.tmw_desktop=ThreadManageWin(self.desktop_winName)
      self.tmw_desktop.setEvtFound(self.tmw_desktop.hide)
      self.tmw_desktop.start()


    self.tmw_app=ThreadManageWin(self.configAppli.winTitlePart, margins={'top': self.configAppli.marginTop, 'bottom': self.configAppli.marginBottom, 'left': self.configAppli.marginLeft, 'right': self.configAppli.marginRight})
    self.tmw_app.setEvtFound(self.tmw_app.enlarge)
    self.tmw_app.start()
    
    if (afklConf.get("afrikalan_desktop_mode", "normal")!="kiosque"):
      self.tmw_panel=ThreadManageWin("panel")
      self.tmw_panel.setEvtFound(self.tmw_panel.hide)
      self.tmw_panel.start()

    
  def runifmainloop(self):
    self.ifDock.mainloop()


boolCmdOptKiosk=False
if sys.argv[1]=="--kiosk":
  boolCmdOptKiosk=True
  sys.argv.pop(1)

arCommandToExec=sys.argv[1:]

####### LockCheck
if not boolCmdOptKiosk:
  lock = open(os.environ['HOME']+'/afrikalanAppliOuverte.lock', 'w+')
  try:
    fcntl.flock(lock, fcntl.LOCK_EX|fcntl.LOCK_NB)
  except:
    print("already running...")
    time.sleep(3)
    fcntl.flock(lock, fcntl.LOCK_UN)
    sys.exit(10)

root=Tk()




afklConf=afrikalan.config.get(["main", "overscan"])

app=AfrikalanRunPlein(arCommandToExec)
app.start()
app.runifmainloop()

#unlock
if not boolCmdOptKiosk:
  fcntl.flock(lock, fcntl.LOCK_UN)
  lock.close()


