#!/usr/bin/env python3.5
#-- coding: utf-8 --

import time
import pprint
import subprocess
import os
import signal

from tkinter import *
from tkinter import messagebox
from tkinter import ttk
from tkinter import font
from PIL import Image, ImageTk

import afrikalan.config



#tkBgColor="#FFFFFF"
tkBgColor="#9c9a8a"
tkHighlightColor="#bdbba7"

class Interface_choixGenre(Frame):
  
  def __init__(self, fenetre):
    self.fenetre=fenetre
    self.choice=False #no choice made when closing? -> quit app
    
    self.fond=tkBgColor;
    
    Frame.__init__(self, self.fenetre, bg=self.fond)
    
    
    
    self.pack(fill=BOTH, expand=True)
    #self.geometry("{0}x{1}+0+0".format(self.root.winfo_screenwidth(), self.root.winfo_screenheight()))
    
    self.content=Frame(self, bg=self.fond)
    self.content.place(relx=.5, rely=.5,anchor= CENTER)
    
    self.message = Label(self.content, text="Clique dans la case qui te correspond", font='Helvetica 24', pady=12, bg=self.fond)
    self.message.grid(row=0, columnspan=2, pady=24)
    
    self.imgFille=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/tokenLogin/choixFille.png")
    self.bouton_ChoixFille = Button(self.content, command=self.evtChoixFille, image=self.imgFille, bg=self.fond)
    self.bouton_ChoixFille.grid(row=1, column=0, padx=75, pady=10)

    self.imgGarcon=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/tokenLogin/choixGarcon.png")
    self.bouton_ChoixGarcon = Button(self.content, command=self.evtChoixGarcon, image=self.imgGarcon, bg=self.fond)
    self.bouton_ChoixGarcon.grid(row=1, column=1, padx=75, pady=10)

    self.lblBas = Label(self.content, text="Cette information est demandée uniquement à des fins statistiques.", font='Helvetica 12', pady=6, bg=self.fond)
    self.lblBas.grid(row=2, column=0, columnspan=2, pady=16)

    
  def evtChoixFille(self):
    self.choice="Fille"
    self.quit()

  def evtChoixGarcon(self):
    self.choice="Garcon"
    self.quit()







class TokenLoginMessageDisplayManager:
  def __init__(self):
    self.boolDisplayed=False
    self.typedchars=""
    self.cbBypassLogin=False


  def displaySelLevel(self):
    if self.boolDisplayed:
      return False

    self.boolDisplayed=True

    self.root=Tk()
    self.root.configure(bg=tkBgColor)
    self.root.attributes('-topmost', True)
    self.root.attributes('-fullscreen', True)
    self.root.title('Afrikalan select class login')
    self.root.geometry("{0}x{1}+0+0".format(self.root.winfo_screenwidth(), self.root.winfo_screenheight()))
    self.root.bind('<KeyPress>', self.onKeyPress)
    self.root.config(cursor="arrow")
    self.frame=Frame_selectclassLogin(self.root)
    self.frame.mainloop()
    return self.frame.choice

  
  def askGender(self):
    interface = Interface_choixGenre(self.root)
    #afrikalan.tkinter.center(self.root)
    interface.mainloop()
    interface.destroy()
    return interface.choice
  
  def stopDisplay(self):
    if not self.boolDisplayed:
      return False
    
    self.boolDisplayed=False
    self.root.destroy()
    
  def updateDisplay(self):
    if self.boolDisplayed:
      self.root.update()
  
  def onKeyPress(self, event):
    self.typedchars+=event.char.upper()
    self.typedchars=self.typedchars[-9:]
    if self.typedchars=="AFRIKALAN" and self.cbBypassLogin is not False:
      self.cbBypassLogin()


class Frame_selectclassLogin(Frame):
  
  def __init__(self, fenetre):
    self.fenetre=fenetre
    
    self.fond=tkBgColor;
    self.fontSize=36
    self.choice=""
    
    Frame.__init__(self, self.fenetre, bg=self.fond)
    
    #self.pack(fill=BOTH, expand=True)
    self.place(relx=.5, rely=.5,anchor= CENTER)
    
    self.Titre = Label(self, text="Clique sur le niveau qui te correspond", font=("sans", self.fontSize), bg=self.fond, fg="#41403b")
    self.Titre.grid(row=0, column=0, columnspan=5, padx=0, pady=60)
  
    self.imgsLevels=[False]*10
    self.lblLevels=[False]*10
    tailleLigne=5
    for i in range(0, 10):
      lev=str(i+1)
      if lev=="10":
        lev="T"
      self.imgsLevels[i]=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/selectLevel/"+lev+".png")
      self.lblLevels[i]=Label(self, image=self.imgsLevels[i], bg=self.fond, bd=0)
      self.lblLevels[i].grid(row=2-(i//tailleLigne), column=i%tailleLigne, padx=0, pady=0)
      self.lblLevels[i].bind('<Button-1>', lambda event, l=lev: self.evtClickClass(l))
      
    frameQuit=Frame(self, bg=self.fond)
    frameQuit.grid(row=3, column=3, columnspan=2, pady=(100,0), sticky = 'e')
    #frameQuit.bind('<Button-1>', self.clicquit)
    self.ImgIconeQuit=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/selectLevel/shutdown.png")
    self.LblIconeQuit=Label(frameQuit, image=self.ImgIconeQuit, bg=self.fond, bd=0)
    self.LblIconeQuit.pack(side=LEFT)
    self.LblIconeQuit.bind('<Button-1>', self.clicquit)
    self.LblTextQuit=Label(frameQuit, text=" Éteindre Afrikalan", font=("sans", 20), bg=self.fond, fg="#4a3f36")
    self.LblTextQuit.pack(side=RIGHT)
    self.LblTextQuit.bind('<Button-1>', self.clicquit)

  def evtClickClass(self, lev):
    self.choice=lev
    self.quit()

    #self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    #self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    #self.bouton_quitter.grid(row=3, column=3, sticky=E, pady=6)

    
  def clicquit(self, event):
    self.choice="Q"
    self.quit()







class TokenLogin:
  def __init__(self):
    self.boolLogged=False
    self.noTokenCount=0
    self.loggedTokenString=""
    self.dm=TokenLoginMessageDisplayManager()
    self.dm.cbBypassLogin=self.bypassLogin
    self.loginBypassed=False
    
    self.loop()
    
  def runLxde(self):
    self.dm.stopDisplay()
    self.boolLogged=True
    self.proc=subprocess.Popen("startlxde", preexec_fn=os.setpgrp) #preexec_fn=os.setpgrp permet de créer un nouveau pgid, et ainsi on pourra tuer le pgid créé sans tuer ce process. On pourrait aussi passer par une autre approche qui serait de créer une nouvelle session mais passer par un nouveau pgid comme on le fait est peut être le mieux, voir: https://stackoverflow.com/questions/23811650/is-there-a-way-to-make-os-killpg-not-kill-the-script-that-calls-it
    self.pg=os.getpgid(self.proc.pid)
    self.proc.communicate() #wait for proc to exit
  
  def logout(self):
    print("LOGGIN OUT")
    self.boolLogged=False
    self.manageLogData("LOGOUT")
    os.killpg(self.pg, signal.SIGTERM)
    #self.dm.startDisplay()

  def bypassLogin(self):
    self.loginBypassed=True
    self.processFoundToken("AFKL-NT")

  def prepareForLevel(self, level):
    #deskDir=os.path.expanduser('~')+"/Bureau"
    #TODO filter not installed apps? (wikipedia sometimes)
    subprocess.run("rm ~/Bureau/*", shell=True)
    subprocess.run(["bash", "-c", "cp -rv /usr/share/afrikalan/niveaux/"+level+"/{*,.[^.]*} ~"])

    
  def manageLogData(self, tokenType, level="", gender=""):
    
    if tokenType!="LOGOUT":
      logf=open("/rw/log.txt", "a")
      logf.write('LevelSelect LOGIN: '+tokenType+','+level+','+gender+'\n')
      logf.close()
      
      logUserInfosf=open("/tmp/AfrikalanInfosUtilisateur.txt", "w")
      logUserInfosf.write(tokenType+','+level+','+gender)
      logUserInfosf.close()
    else:
      logf=open("/rw/log.txt", "a")
      logf.write('LevelSelect LOGOUT:\n')
      logf.close()
     
      subprocess.run(["rm", "-f", "/tmp/AfrikalanInfosUtilisateur.txt"])
    

  def loop(self):
  #On va faire une boucle infinie pour lire en boucle
    while True :
      level=self.dm.displaySelLevel()
      if afklConf.get("afrikalan_selectLevelAskGender", "0")=="1" and level !="Q": #Gender must be asked before display destruction
        gender=self.dm.askGender()
      else:
        gender=""
        
      self.dm.stopDisplay()
      
      if level=="Q":
        #if messagebox.askyesno(message="Voulez-vous éteindre Afrikalan?"):
        break
      else:       
        self.manageLogData("ManualLogin", level, gender)
        self.prepareForLevel(level)
        self.runLxde()
        
        #xcfe ended
        self.logout()



afklConf=afrikalan.config.get(["main"])
TokenLogin()
