#!/usr/bin/env python3.5
#-- coding: utf-8 --

import RPi.GPIO as GPIO #Importe la bibliothèque pour contrôler les GPIOs
from pirc522 import RFID
#import MFRC522
import time
import pprint
import subprocess
import os
import signal

from tkinter import *
from tkinter import messagebox
from tkinter import ttk
from tkinter import font
from PIL import Image, ImageTk

tkBgColor="#FFFFFF"


class Interface_choixGenre(Frame):
  
  def __init__(self, fenetre):
    self.fenetre=fenetre
    self.choice=False #no choice made when closing? -> quit app
    
    self.fond=tkBgColor;
    
    Frame.__init__(self, self.fenetre, bg=self.fond)
    
    
    
    self.pack(fill=BOTH, expand=True)
    #self.geometry("{0}x{1}+0+0".format(self.root.winfo_screenwidth(), self.root.winfo_screenheight()))
    
    self.content=Frame(self, bg=self.fond)
    self.content.place(relx=.5, rely=.5,anchor= CENTER)
    
    self.message = Label(self.content, text="Clique dans la case qui te correspond", font='Helvetica 24', pady=12, bg=self.fond)
    self.message.grid(row=0, columnspan=2, pady=24)
    
    self.imgFille=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/tokenLogin/choixFille.png")
    self.bouton_ChoixFille = Button(self.content, command=self.evtChoixFille, image=self.imgFille, bg=self.fond)
    self.bouton_ChoixFille.grid(row=1, column=0, padx=75, pady=10)

    self.imgGarcon=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/tokenLogin/choixGarcon.png")
    self.bouton_ChoixGarcon = Button(self.content, command=self.evtChoixGarcon, image=self.imgGarcon, bg=self.fond)
    self.bouton_ChoixGarcon.grid(row=1, column=1, padx=75, pady=10)

    self.lblBas = Label(self.content, text="Cette information est demandée uniquement à des fins statistiques.", font='Helvetica 12', pady=6, bg=self.fond)
    self.lblBas.grid(row=2, column=0, columnspan=2, pady=16)

    
  def evtChoixFille(self):
    self.choice="Fille"
    self.quit()

  def evtChoixGarcon(self):
    self.choice="Garcon"
    self.quit()







class TokenLoginMessageDisplayManager:
  def __init__(self):
    self.boolDisplayed=False
    self.typedchars=""
    self.cbBypassLogin=False


  def startDisplay(self):
    if self.boolDisplayed:
      return False

    self.boolDisplayed=True

    self.root=Tk()
    self.root.configure(bg=tkBgColor)
    self.root.attributes('-topmost', True)
    self.root.attributes('-fullscreen', True)
    self.root.title('Afrikalan token login')
    #self.root.geometry("1280x1024")
    self.root.geometry("{0}x{1}+0+0".format(self.root.winfo_screenwidth(), self.root.winfo_screenheight()))
    self.root.bind('<KeyPress>', self.onKeyPress)
    self.frame=Frame_tokenLogin(self.root)
    self.frame.update()
  
  def askGender(self):
    interface = Interface_choixGenre(self.root)
    self.root.config(cursor="arrow")
    #afrikalan.tkinter.center(self.root)
    interface.mainloop()
    interface.destroy()
    return interface.choice
  
  def stopDisplay(self):
    if not self.boolDisplayed:
      return False
    
    self.boolDisplayed=False
    self.root.destroy()
    
  def updateDisplay(self):
    if self.boolDisplayed:
      self.root.update()
  
  def onKeyPress(self, event):
    self.typedchars+=event.char.upper()
    self.typedchars=self.typedchars[-9:]
    if self.typedchars=="AFRIKALAN" and self.cbBypassLogin is not False:
      self.cbBypassLogin()


class Frame_tokenLogin(Frame):
  
  def __init__(self, fenetre):
    self.fenetre=fenetre
    
    self.fond=tkBgColor;
    self.fontSize=28
    
    Frame.__init__(self, self.fenetre, bg=self.fond)
    
    #self.pack(fill=BOTH, expand=True)
    self.place(relx=.5, rely=.5,anchor= CENTER)
    
    self.imgEtape1=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/tokenLogin/TokenLogin1.png")
    self.Etape1Img=Label(self, image=self.imgEtape1, bg=self.fond)
    self.Etape1Img.grid(row=0, column=0, padx=70, pady=20)

    self.Etape1Lbl = Label(self, text="1: Demande au bibliothécaire\nla carte qui correspond à\nta classe.", font=("sans", self.fontSize), bg=self.fond)
    self.Etape1Lbl.grid(row=1, column=0, padx=0, pady=20)
      

    self.imgEtape2=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/tokenLogin/TokenLogin2.png")
    self.Etape2Img=Label(self, image=self.imgEtape2, bg=self.fond)
    self.Etape2Img.grid(row=0, column=1, padx=70, pady=20)

    self.Etape2Lbl = Label(self, text="2: Dépose la carte sur\nle boitier Afriklan.", font=("sans", self.fontSize), bg=self.fond)
    self.Etape2Lbl.grid(row=1, column=1, padx=0, pady=20)



    #self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    #self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    #self.bouton_quitter.grid(row=3, column=3, sticky=E, pady=6)

    
  def suppr(self):
    self.quit()





def block2str(a):
  s=""
  for e in a:
    if e!=0:
      s+=chr(e)
  return s

def check_for_tag(rdr, timeout=1):
	# enable IRQ on detect
	startTime = time.time()
	rdr.init()
	rdr.irq.clear()
	rdr.dev_write(0x04, 0x00)
	rdr.dev_write(0x02, 0xA0)
	# wait for it
	waiting = True
	while waiting and time.time() - startTime < timeout:
		rdr.dev_write(0x09, 0x26)
		rdr.dev_write(0x01, 0x0C)
		rdr.dev_write(0x0D, 0x87)
		waiting = not rdr.irq.wait(0.1)
	rdr.irq.clear()
	rdr.init()
	return not waiting

class TokenLogin:
  def __init__(self):
    self.NOTOKENGRACETIME=1
    self.boolLogged=False
    self.noTokenCount=0
    self.loggedTokenString=""
    self.dm=TokenLoginMessageDisplayManager()
    self.dm.startDisplay()
    self.dm.cbBypassLogin=self.bypassLogin
    self.loginBypassed=False
    
    self.loop()
    
  def loginLxde(self, tokenDataString):
    self.dm.stopDisplay()
    print("LOGGIN IN LXDE ["+tokenDataString+"]")
    self.boolLogged=True
    self.proc=subprocess.Popen("startlxde", preexec_fn=os.setpgrp) #preexec_fn=os.setpgrp permet de créer un nouveau pgid, et ainsi on pourra tuer le pgid créé sans tuer ce process. On pourrait aussi passer par une autre approche qui serait de créer une nouvelle session mais passer par un nouveau pgid comme on le fait est peut être le mieux, voir: https://stackoverflow.com/questions/23811650/is-there-a-way-to-make-os-killpg-not-kill-the-script-that-calls-it
    print ("PID "+str(self.proc.pid))
  
  def logout(self):
    print("LOGGIN OUT")
    self.boolLogged=False
    self.manageLogData("LOGOUT")
    os.killpg(os.getpgid(self.proc.pid), signal.SIGTERM)
    #subprocess.run(["killall", "lxsession"])
    self.dm.startDisplay()

  def bypassLogin(self):
    self.loginBypassed=True
    self.processFoundToken("AFKL-NT")

  def prepareForLevel(self, level):
    #deskDir=os.path.expanduser('~')+"/Bureau"
    #TODO filter not installed apps? (wikipedia sometimes)
    subprocess.run("rm ~/Bureau/*", shell=True)
    subprocess.run(["bash", "-c", "cp -rv /usr/share/afrikalan/niveaux/"+level+"/{*,.[^.]*} ~"])

  def processFoundToken(self, tokenDataString):
    if self.boolLogged and tokenDataString!=self.loggedTokenString:
      self.logout()
      
    if tokenDataString[:5]!="AFKL-" or len(tokenDataString)<7: #Token invalide
      return False

    self.loggedTokenString=tokenDataString

    if tokenDataString[5]=="N":
      if not self.boolLogged:
        level=tokenDataString[6]
        self.prepareForLevel(level)
        gender=self.getGenderData(tokenDataString)
        
        self.manageLogData("LEVEL", level, gender)
        self.loginLxde(tokenDataString)
      
  def getGenderData(self, tokenDataString):
    gender=""
    
    if len(tokenDataString)>=9:
      genderChar=tokenDataString[8]
    else:
      genderChar=""
      
    if genderChar=="F":
      gender="Fille"
    if genderChar=="G":
      gender="Garcon"
    if genderChar=="?":
      gender=self.dm.askGender()
      
    return gender
  
    
  def manageLogData(self, tokenType, level="", gender=""):
    pprint.pprint(tokenType)
    pprint.pprint(level)
    pprint.pprint(gender)
    
    if tokenType!="LOGOUT":
      logf=open("/rw/log.txt", "a")
      logf.write('TOKEN LOGIN: '+tokenType+','+level+','+gender+'\n')
      logf.close()
      
      logUserInfosf=open("/tmp/AfrikalanInfosUtilisateur.txt", "w")
      logUserInfosf.write(tokenType+','+level+','+gender)
      logUserInfosf.close()
    else:
      logf=open("/rw/log.txt", "a")
      logf.write('TOKEN LOGOUT:\n')
      logf.close()
     
      subprocess.run(["rm", "-f", "/tmp/AfrikalanInfosUtilisateur.txt"])
    

  def loop(self):
  #On va faire une boucle infinie pour lire en boucle
    iteCount=0
    lastreadOk=False
    while True :
      iteCount+=1
      self.dm.updateDisplay()
      
      if self.boolLogged: 
        #Check if running WM exited
        if self.proc.poll() is not None:
          # poll != None => le process est terminé
          print("Le processus enfant s'est arreté, fin de la boucle")
          return False #On arrete la boucle, fin du programme, exinction d'Afrikalan
      
      boolTag=check_for_tag(rc522, 1)


      if boolTag : #Si on a pas d'erreur
          if lastreadOk:
            self.noTokenCount=0;
          if self.boolLogged and iteCount%60!=0 and lastreadOk:
            time.sleep(1)
            continue #ne pas lire inutilement si tag déja reconnu= économie important de CPU. Par contre On perd la possibilité de détecter le changement de tag... toutefois, une revérification chaque 60s
          
          lastreadOk=False
          
          (error, tag_type) = rc522.request() #Quand une puce a été lue, on récupère ses infos
          if not error:
            (error, uid) = rc522.anticoll() #On nettoie les possibles collisions, ça arrive si plusieurs cartes passent en même temps

            if not error : #Si on a réussi à nettoyer
              if not rc522.select_tag(uid):
                # Auth for block 10 (block 2 of sector 2) using default shipping key A
                if not rc522.card_auth(rc522.auth_a, 10, [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF], uid):
                  print("Reading block 10:")
                  tokenDataString=block2str(rc522.read(10)[1])
                  # Always stop crypto1 when done working
                  rc522.stop_crypto()
                  
                  lastreadOk=True
                  self.processFoundToken(tokenDataString)
                  
          if error:
            time.sleep(1)



      if not boolTag or not lastreadOk:
        print('En attente d\'un badge (pour quitter, Ctrl + c): ') #On affiche un message demandant à l'utilisateur de passer son badge
        self.noTokenCount+=1
        if self.noTokenCount>self.NOTOKENGRACETIME and self.boolLogged and not self.loginBypassed:
          self.logout()
          



       




GPIO.setmode(GPIO.BOARD) #Définit le mode de numérotation (Board)
GPIO.setwarnings(False) #On désactive les messages d'alerte

rc522 = RFID() #On instancie la lib

TokenLogin()
