#!/usr/bin/env python3.5
#-- coding: utf-8 --

import RPi.GPIO as GPIO #Importe la bibliothèque pour contrôler les GPIOs
from pirc522 import RFID
#import MFRC522
import time
import sys


GPIO.setmode(GPIO.BOARD) #Définit le mode de numérotation (Board)
GPIO.setwarnings(False) #On désactive les messages d'alerte

rc522 = RFID() #On instancie la lib

def str2block(s):
  TARGETLEN=16
  
  s=s[:15]
  r=[ord(c) for c in s]
  r+= [0] * (TARGETLEN - len(r))
  return r

if len(sys.argv)>=2:
  strToWrite=sys.argv[1]
else:
  strToWrite=""

#On va faire une boucle infinie pour lire en boucle
while True :
    (error, tag_type) = rc522.request() #Quand une puce a été lue, on récupère ses infos

    if not error : #Si on a pas d'erreur
        (error, uid) = rc522.anticoll() #On nettoie les possibles collisions, ça arrive si plusieurs cartes passent en même temps

        if not error : #Si on a réussi à nettoyer
            print('Vous avez passé le badge avec l\'id : {}'.format(uid)) #On affiche l'identifiant unique du badge RFID

        if not rc522.select_tag(uid):
          # Auth for block 10 (block 2 of sector 2) using default shipping key A
          if not rc522.card_auth(rc522.auth_a, 10, [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF], uid):
            # This will print something like (False, [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0])
            print("writing block 10: " + str(rc522.write(10, str2block(strToWrite))))
            print("Reading block 10: " + str(rc522.read(10)))
            # Always stop crypto1 when done working
            rc522.stop_crypto()
            break


    if error:
      print('En attente d\'un badge (pour quitter, Ctrl + c): ') #On affiche un message demandant à l'utilisateur de passer son badge


    time.sleep(1) #On attend 1 seconde pour ne pas lire le tag des centaines de fois en quelques milli-secondes

