#!/usr/bin/python3

#obexftp --nopath --noconn --uuid none --bluetooth MAC_address --channel channel --put file
##sdptool browse 00:16:20:60:7C:36

from tkinter import *
from tkinter import messagebox
from tkinter import ttk
from tkinter import font

import afrikalan.transfer.handler
import afrikalan.tkinter

from PIL import Image, ImageTk
from lxml import etree
import subprocess
from pprint import pprint
import threading
import time
import datetime
import os
import sys
import glob
import textwrap


import argparse

import bluetooth                     
import select
import time


glob_dialog_bg="#F8F8F8"
glob_dialog_padx=24
glob_dialog_pady=10
glob_infoframe_bg="#FFFFFF"
glob_button_bg="#E0E0E0" #was: #D4D4D4


#####################################
# Partie relative à l'interface
#####################################


#
# Interfaces transversales
#


class Interface_choixMethode(Frame):
  
  def __init__(self, fenetre, availableModes, nomElt="cette application"):
    self.fenetre=fenetre
    self.availableModes=availableModes
    self.nomElt=nomElt
    self.choice=False #no choice made when closing? -> quit app
    
    self.fond=glob_dialog_bg;
    
    Frame.__init__(self, self.fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    
    self.pack(fill=BOTH)
    
    self.message = Label(self, text="Vous pouvez transférer "+self.nomElt+":", font='Helvetica 20', pady=12, bg=self.fond)
    self.message.grid(row=0, columnspan=4)
    
    col=0

    if self.availableModes['usb']==1:
      self.imgMethodeUSB=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_transfert_USB.png")
      self.bouton_ChoixMethodeUSB = Button(self, command=self.evtChoixMethodeUSB, image=self.imgMethodeUSB, bg=glob_button_bg)
      self.bouton_ChoixMethodeUSB.grid(row=1, column=col, columnspan=2, padx=10, pady=10)

      self.label_ChoixMethodeUSB = Label(self, text="Pour utiliser sur votre ordinateur ou \ndans un cyber.", bg=self.fond)
      self.label_ChoixMethodeUSB.grid(row=2, column=col, columnspan=2, padx=10, pady=10)
      
      col+=2


    if self.availableModes['bluetooth']==1:
      self.imgMethodeBT=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_transfert_blueTooth.png")
      self.bouton_ChoixMethodeBT = Button(self, image=self.imgMethodeBT, command=self.evtChoixMethodeBT, bg=glob_button_bg)
      self.bouton_ChoixMethodeBT.grid(row=1, column=col, columnspan=2, padx=10, pady=10)
    
      self.label_ChoixMethodeBt = Label(self, text="Pour utiliser sur votre téléphone", bg=self.fond)
      self.label_ChoixMethodeBt.grid(row=2, column=col, columnspan=2, padx=10, pady=10)
      
      col+=2


    if self.availableModes['wifi']==1:
      self.imgMethodeWIFI=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_transfert_WIFI.png")
      self.bouton_ChoixMethodeWIFI = Button(self, image=self.imgMethodeWIFI, command=self.evtChoixMethodeWIFI, bg=glob_button_bg)
      self.bouton_ChoixMethodeWIFI.grid(row=1, column=col, columnspan=2, padx=10, pady=10)
    
      self.label_ChoixMethodeWIFI = Label(self, text="Pour utiliser sur votre téléphone ou \nvotre ordinateur", bg=self.fond)
      self.label_ChoixMethodeWIFI.grid(row=2, column=col, columnspan=2, padx=10, pady=10)
      
      col+=2


    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    self.bouton_quitter.grid(row=3, column=3, sticky=E, pady=6)

    
  def evtChoixMethodeBT(self):
    self.choice="BT"
    self.quit()

  def evtChoixMethodeUSB(self):
    self.choice="USB"
    self.quit()

  def evtChoixMethodeWIFI(self):
    self.choice="WIFI"
    self.quit()



class Interface_Patienter(Frame):
  
  def __init__(self, fenetre):
    self.fenetre=fenetre
    self.fond=glob_dialog_bg
    self.tickAnimStep=0
    self.tickDelay=400
    self.exited=False
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    
    self.pack(fill=BOTH)
    
    self.message = Label(self, text="Veuillez Patienter...", pady=12, bg=self.fond, font='Helvetica 16')
    self.message.grid(row=0, columnspan=4)
    self.progress = ttk.Progressbar(self, orient="horizontal", length=400, mode="indeterminate")
    self.progress.grid(row=1, columnspan=4)
    self.progress.start()

    Frame(self, height=20, bg=self.fond).grid(row=2, column=1) #V-Separator

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    self.bouton_quitter.grid(row=3, column=3, sticky=E, pady=6)  
  

  #catch quit event
  def quit(self):
    self.exited=True;
    super().quit()
  


class FlavourChooser:
  def __init__(self, tkcontainer, confhandler, descwrap=90):
    self.tkcontainer=tkcontainer
    self.confhandler=confhandler
    self.descwrap=descwrap
    self.fond=self.tkcontainer.fond
    self.openedIfChoose=False
    
    self.tkwidget=Frame(self.tkcontainer, bg=self.fond, pady=16)
    
    self.frameTitle=Frame(self.tkwidget)
    self.lblBlocTitle=Label(self.frameTitle, text="Ce qui va être envoyé: ", bg=self.fond)
    self.lblBlocTitle.pack(side=LEFT)

    self.lblSelFalvourName=Label(self.frameTitle, bg=self.fond, fg="#555555")
    fontName=font.Font(self.lblSelFalvourName, self.lblSelFalvourName.cget("font"))
    fontName.configure(weight="bold")
    self.lblSelFalvourName.configure(font=fontName)
    self.lblSelFalvourName.pack(side=LEFT)
    
    self.frameTitle.grid(row=0, column=0, columnspan=3, sticky="w")
    
    if self.descwrap>=90:
      linkContainer=self.frameTitle
    else:
      linkContainer=Frame(self.tkwidget)
      linkContainer.grid(row=1, columnspan=3, sticky="E")
      
    self.lblChangeLink=afrikalan.tkinter.Link(linkContainer, text="Choisir autre chose", bg=self.fond, cursor="hand1", fg="#0000EE", justify="right", command=self.evtOpenChooser) #underline=
    Label(linkContainer, text=" [", bg=self.fond).pack(side=LEFT)
    self.lblChangeLink.pack(side=LEFT)
    Label(linkContainer, text="]", bg=self.fond).pack(side=LEFT)

    self.lblSelFlavourDescription=Label(self.tkwidget, bg=self.fond, justify="left")
    fontDesc=font.Font(self.lblSelFlavourDescription, self.lblSelFlavourDescription.cget("font"))
    fontDesc.configure(slant="italic")
    self.lblSelFlavourDescription.configure(font=fontDesc)
    self.lblSelFlavourDescription.grid(row=2, column=0, columnspan=3, sticky="W")
    
    self.updateDisplaySelFlavour()

  def evtOpenChooser(self):
    if self.openedIfChoose is not False:
      self.openedWinChoose.destroy()
      
    self.openedWinChoose=Toplevel(root)
    self.openedWinChoose.attributes('-topmost', True)
    self.openedIfChoose=Interface_ChangeFlavour(self.openedWinChoose, self.confhandler, self.evtChooserSelect)
    afrikalan.tkinter.center(self.openedWinChoose)
    
  
  def evtChooserSelect(self, choice):
    self.confhandler.setSelectedFlavour(choice)
    self.updateDisplaySelFlavour()
    

  def updateDisplaySelFlavour(self):
    flavourData=self.confhandler.getSelectedFlavourData()
    self.lblSelFalvourName.configure(text=flavourData.get('name'))
    if flavourData.get('description') is not False:
      arlines=textwrap.wrap(flavourData.get('description'), self.descwrap)
      self.lblSelFlavourDescription.configure(text="\n".join(arlines))


class Interface_ChangeFlavour(Frame):
  
  def __init__(self, fenetre, confhandler, cbSelect):
    self.choice=False
    self.fenetre=fenetre
    self.fond=glob_dialog_bg
    self.confhandler=confhandler
    self.cbSelect=cbSelect
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    
    self.pack(fill=BOTH)
    
    self.message = Label(self, text="Veuillez choisir ce qui vous convient:", pady=18, bg=self.fond, font='Helvetica 16')
    self.message.grid(row=0, columnspan=5)
    
    self.frmChoices=Frame(self, bg=self.fond)
    self.genChoicesWidgets(self.frmChoices)
    self.frmChoices.grid(row=1, column=0, columnspan=5)

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.fenetre.destroy, bg=glob_button_bg)
    self.bouton_quitter.grid(row=3, column=4, sticky="E", pady=6)  

  def genChoicesWidgets(self, container):
    flavours=self.confhandler.getFlavoursData() #{'id': ..., 'name': ..., 'description': ...}

    actrow=0
    fontDesc=False
    fontName=False
    
    for flavour in flavours:
      evtChoosen=lambda e=False, cb=self.evtFlavourSelected, selectedId=flavour.get('id') : cb(selectedId)
      
      lblName=Label(container, text=flavour.get('name'), justify="left", bg=self.fond, fg="#555555")
      if fontName is False:
        fontName=font.Font(lblName, lblName.cget("font"))
        fontName.configure(weight="bold")
      lblName.configure(font=fontName)
      lblName.grid(row=actrow, column=0, sticky="w")
      lblName.bind("<Button-1>", evtChoosen)
      
      Frame(container, width=16, bg=self.fond).grid(row=actrow, column=1) #H-Separator
      
      btnChoose=Button(container, text="Choisir", command=evtChoosen, bg=glob_button_bg)
      btnChoose.grid(row=actrow, rowspan=2, column=2)
      
      
      
      if flavour.get('description') is not False:
        arlines=textwrap.wrap(flavour.get('description'))

        lblDescr=Label(container, text="\n".join(arlines), justify="left", bg=self.fond)
        if fontDesc is False:
          fontDesc=font.Font(lblDescr, lblDescr.cget("font"))
          fontDesc.configure(slant="italic")
        lblDescr.configure(font=fontDesc)
        lblDescr.bind("<Button-1>", evtChoosen)

        lblDescr.grid(row=actrow+1, column=0, sticky="w")

      Frame(container, height=24, bg=self.fond).grid(row=actrow+2, column=0) #H-Separator

      actrow+=3

        

    
  #Event: Target bluetooth host selected by user
  def evtFlavourSelected(self, flavourId):
    self.fenetre.destroy()
    self.cbSelect(flavourId)

def kmgt(num, unit='o', threshold=1000, decimals=1):
  mult=''
  if num>threshold:
    mult='K'
    num/=1000
  if num>threshold:
    mult='M'
    num/=1000
  if num>threshold:
    mult='G'
    num/=1000
  if num>threshold:
    mult='T'
    num/=1000
  return(str(round(num, decimals))+' '+mult+unit)

class SpeedCalc:
  def __init__(self, size=5):
    self.size=size
    self.arRecord=[];
    self.record(0)
    
  def record(self, pos):
    self.arRecord.append([datetime.datetime.now(), pos])
    
    if len(self.arRecord)>self.size:
      self.arRecord.pop(0)
  
  def get(self):
    if len(self.arRecord)<2:
      return(0)
    else:
      lastId=len(self.arRecord)-1
      size=self.arRecord[lastId][1]-self.arRecord[0][1]
      time=(self.arRecord[lastId][0]-self.arRecord[0][0]).total_seconds()
      return (size/time)



#
# Interfaces for bluetooth transfer
#

class Interface_destBlueTooth(Frame):
  
  def __init__(self, fenetre, confhandler):
    self.choice=False
    self.fenetre=fenetre
    self.fond=glob_dialog_bg
    self.tickAnimStep=0
    self.tickDelay=400
    self.confhandler=confhandler
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    
    self.pack(fill=BOTH)
    
    self.message = Label(self, text="Veuillez sélectionner votre appareil dans la liste:", pady=18, bg=self.fond, font='Helvetica 16')
    self.message.grid(row=0, columnspan=5)

    self.lbDests=Listbox(self, font='Helvetica 14', bg="#FFFFFF", width=24, height=12)
    self.lbDests.grid(row=1, column=0, columnspan=2)
    self.paintEmptydest()
    self.lbDests.bind('<<ListboxSelect>>', self.on_select)
    self.selReady=False
    
    sep=Frame(self, width=16, bg=self.fond)
    btHelpFrame=self.btHelpFrame()
    btHelpFrame.grid(row=1, column=3, columnspan=2)
    #styleInvisible = ttk.Style()
    #styleInvisible.configure("Line.TSeparator", background="#FFFFFF")
    #sep = ttk.Separator(self, orient=VERTICAL, style="Line.TSeparator")
    sep.grid(row=1, column=2, padx=8, pady=2, sticky="ns")
    
    if self.confhandler.hasFlavours:
      Frame(self, height=8, bg=self.fond).grid(row=2, column=0) #H-Separator
      self.flavourChooser=FlavourChooser(self, self.confhandler)
      self.flavourChooser.tkwidget.grid(row=3, column=0, columnspan=5, sticky="WE")
    else:
      Frame(self, height=24, bg=self.fond).grid(row=2, column=1) #V-Separator

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    self.bouton_quitter.grid(row=4, column=4, sticky="E", pady=6)  

    
    
    self.fenetre.after(self.tickDelay, self.tickAnim())
  
  #Draw a tk frame with instructions in case the phone doesn't appear.
  def btHelpFrame(self):
    fghelp="#444444"
    colorCons="#666666"
    conseilsBg=glob_infoframe_bg
    padyCons=4
    helpFrame=Frame(self, width=100, bg=conseilsBg, padx=10)
    titre=Label(helpFrame, text = "Votre téléphone n'apparait pas ?", font='Helvetica 11 bold', bg=conseilsBg, fg=fghelp)
    titre.pack()
    sousTitre=Label(helpFrame, text = "Essayez ces conseils:", bg=conseilsBg, pady=10, fg=fghelp)
    sousTitre.pack()
    conseil1=Label(helpFrame, text = "1/ Vérifiez que le Bluetooth est bien\n    activé sur votre téléphone.", bg=conseilsBg, justify=LEFT, fg=colorCons, pady=padyCons, anchor='w')
    conseil1.pack(fill='both')
    #2/ 
    conseil2=Label(helpFrame, text = "2/ Gardez l'écran de votre téléphone\n    allumé et déverrouillé.", bg=conseilsBg, justify=LEFT, fg=colorCons, pady=padyCons, anchor='w')
    conseil2.pack(fill='both')
    conseil3=Label(helpFrame, text = "3/ Allez dans les paramètres puis\n    sur la page 'Bluetooth'.\n    Gardez cette page affichée\n    à l'écran.", bg=conseilsBg, justify=LEFT, fg=colorCons, pady=padyCons, anchor='w')
    conseil3.pack(fill='both')
    conseil4=Label(helpFrame, text = "4/ S'il existe une option appelée\n    'identifiable', ou 'visible', activez-là.", bg=conseilsBg, justify=LEFT, fg=colorCons, pady=padyCons, anchor='w')
    conseil4.pack(fill='both')
    conseil5=Label(helpFrame, text = "5/ Essayez d'éteindre puis de\n    rallumer le Bluetooth sur votre\n    téléphone.", bg=conseilsBg, justify=LEFT, fg=colorCons, pady=padyCons, anchor='w')
    conseil5.pack(fill='both')
    conseilfin=Label(helpFrame, text = "Soyez patients... Le téléphone\npeut mettre quelques dizaines\nde secondes pour apparaître.", bg=conseilsBg, justify=LEFT, fg=fghelp)
    conseilfin.pack(fill='both')
    return(helpFrame)
    
    
  #Draw listbox of target bluetooth host showing "searching..." when no host has been discovered yet...
  def paintEmptydest(self):
    self.lbDests.configure(fg="#666666", font='Helvetica 16 italic')
    self.lbDests.delete(0, 'end')
    self.lbDests.insert(END, "")
    self.lbDests.insert(END, "")
    self.lbDests.insert(END, "")
    self.lbDests.insert(END, "")
    self.lbDests.insert(END, "")
    self.lbDests.insert(END, "              Recherche"+("."*(self.tickAnimStep%5)))
    self.lbDests.insert(END, "")
  
  #Update listbox of destinations when data about avaible bluetooth hosts has been received
  def majLbDests(self, arDests):
    if len(arDests)==0:
      self.paintEmptydest()
      self.selReady=False
    else:
      self.lbDests.delete(0, 'end')
      self.lbDests.configure(fg="#000000", font='Helvetica 16')
      self.arDests=arDests
      
      for dest in self.arDests:
        pprint(dest)
        self.lbDests.insert(END, dest['name'])
      
      self.selReady=True
    
    
  #Event: Target bluetooth host selected by user
  def on_select(self, evt):
    if not self.selReady:
      return False
    
    index = int(evt.widget.curselection()[0])
    self.choice=self.arDests[index]['mac']
    self.choiceName=self.arDests[index]['name']
    self.quit()
    
  def tickAnim(self):
    self.tickAnimStep+=1
    
    if not self.selReady:
      self.lbDests.delete(5)
      self.lbDests.insert(5, "              Recherche"+("."*(self.tickAnimStep%4)))
    
    self.fenetre.after(self.tickDelay, self.tickAnim)




class Interface_blueToothWaitAccept(Frame):
  
  def __init__(self, fenetre, evtCancel):
    self.evtCancel=evtCancel
    self.fenetre=fenetre
    self.fond=glob_dialog_bg
    self.tickAnimStep=0
    self.tickDelay=400
    self.exited=0
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    
    self.pack(fill=BOTH)
    
    self.titre = Label(self, text="En attente d'acceptation:", pady=16, padx=6, bg=self.fond, font='Helvetica 16')
    self.titre.grid(row=0, columnspan=4)
    
    self.conseil = Label(self, text="Une notification s'affiche sur votre téléphone.\nVeuillez l'ouvrir pour accepter le tranfert.", pady=0, bg=self.fond)
    self.conseil.grid(row=1, columnspan=4)

    Frame(self, height=16, bg=self.fond).grid(row=2) #V-Separator
    self.genAnimAccept()
    self.lblAnimAcceptImages.grid(row=3, columnspan=4)
    Frame(self, height=24, bg=self.fond).grid(row=4) #V-Separator

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.btnQuit, bg=glob_button_bg)
    self.bouton_quitter.grid(row=5, column=3, sticky=E, pady=6)  
    
    self.fenetre.after(self.tickDelay, self.tickAnim)
  
  def genAnimAccept(self):
    self.animAcceptImages=[]
    for i in range(8):
      self.animAcceptImages.append(ImageTk.PhotoImage(file = "/usr/share/afrikalan/images/transfert/openNotif"+str(i)+".png"))  
    self.lblAnimAcceptImages=Label(self, image=self.animAcceptImages[0], pady=20)
    
  def cycleAnimAccept(self):
    stepmap=[0, 0, 0, 1, 2, 3, 4, 4, 5, 5, 6, 6, 7, 5, 7, 5, 7, 5, 7, 7]
    self.lblAnimAcceptImages.configure(image=self.animAcceptImages[stepmap[self.tickAnimStep%len(stepmap)]])
      
      
  def btnQuit(self):
    self.evtCancel()

  #catch quit event
  def quit(self):
    super().quit()
  
    
  def tickAnim(self):
    if self.exited:
      return(False)
    self.tickAnimStep+=1
    self.cycleAnimAccept()
    self.fenetre.after(self.tickDelay, self.tickAnim)



class Interface_blueToothSending(Frame):
  
  def __init__(self, fenetre, filename, evtCancel):
    self.evtCancel=evtCancel
    self.fenetre=fenetre
    self.filename=filename
    self.fond=glob_dialog_bg
    self.tickAnimStep=0
    self.tickDelay=400
    self.exited=False
    self.lightText="#606060"
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    self.pack(fill=BOTH)
    
    
    self.genAnimEnvoi()
    self.lblAnimEnvoiImages.grid(row=0, column=0, rowspan=3)
    
    self.titre = Label(self, text="Envoi en cours"+("."*(self.tickAnimStep%4))+(" "*(4-self.tickAnimStep%4)), pady=6, bg=self.fond, font='Helvetica 16')
    self.titre.grid(row=0, column=1, columnspan=3)
    
    self.affFich = Label(self, text="Fichier envoyé: "+self.filename, padx=10, pady=6, bg=self.fond, font='Helvetica 12')
    self.affFich.grid(row=1, column=1, columnspan=3)

    #self.message = Label(self, text="Vous pouvez suivre la progression du transfert sur\n l'écran de votre téléphone (dans vos notifications)", pady=6, padx=10, bg=self.fond, anchor='w')
    #self.message.grid(row=2, column=1, columnspan=3, sticky='w')

    self.progress = ttk.Progressbar(self, orient="horizontal", length=300, mode="determinate", value=0)
    self.progress.grid(row=2, column=1, columnspan=3, sticky='w')
    
    self.lblSpeed = Label(self, text="", pady=6, padx=10, bg=self.fond, anchor='e', fg=self.lightText)
    self.lblSpeed.grid(row=3, column=1, columnspan=3, sticky='e')
    
    self.manShown=False   #ROW 4
    self.frmMan=Frame(self, bg=self.fond)
    #self.frmMan.grid(row=4, column=1)
    self.lblManStart=Label(self.frmMan, bg=self.fond, text="Astuce:")
    self.lblManStart.pack(side=LEFT)
    self.lblLinkMan=afrikalan.tkinter.Link(self.frmMan, text="Télécharger plus rapidement avec le Wifi", bg=self.fond, fg="#599de3", justify="right", command=self.evtInfosWifi) #underline=
    self.lblLinkMan.pack(side=LEFT)
    
    Frame(self, height=20, bg=self.fond).grid(row=5, column=1) #V-Separator
    

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.btnQuit, bg=glob_button_bg)
    self.bouton_quitter.grid(row=6, column=3, sticky=E, pady=6)  
    
    self.fenetre.after(self.tickDelay, self.tickAnim())

  def evtInfosWifi(self):
    subprocess.Popen(['afrikalanAffMan.py', '/usr/share/doc/afrikalan/guides/telechWifi/telechWifi.xml'])

  def genAnimEnvoi(self):
    self.animEnvoiImages=[]
    for i in range(4):
      self.animEnvoiImages.append(ImageTk.PhotoImage(file = "/usr/share/afrikalan/images/transfert/envoi"+str(i)+".png"))  
    self.lblAnimEnvoiImages=Label(self, image=self.animEnvoiImages[0], pady=20, bg=self.fond)
    
  def cycleAnimEnvoi(self):
    stepmap=[0, 1, 2, 3]
    self.lblAnimEnvoiImages.configure(image=self.animEnvoiImages[stepmap[self.tickAnimStep%len(stepmap)]])

  def updateProgr(self, pos, total, speed):
    if self.exited:
      return(False)
    
    if not self.manShown and total>4000000:
      self.frmMan.grid(row=4, column=1, columnspan=3)
      self.manShown=True

    self.progress.configure(value=pos, maximum=total)
    self.lblSpeed.configure(text="Vitesse: "+speed+" -- Taille: "+kmgt(total, threshold=10000) )
  
  def btnQuit(self):
    self.evtCancel()

  #catch quit event
  def quit(self):
    super().quit()
  
    
  def tickAnim(self):
    if self.exited:
      return(False)
    self.tickAnimStep+=1
    self.titre.configure(text="Envoi en cours"+("."*(self.tickAnimStep%4))+(" "*(4-self.tickAnimStep%4)))
    self.cycleAnimEnvoi()
    self.fenetre.after(self.tickDelay, self.tickAnim)






#
# Interfaces for USB transfer
#
class Interface_waitUsb(Frame):
  
  def __init__(self, fenetre, confhandler):
    self.fenetre=fenetre
    self.fond=glob_dialog_bg
    self.confhandler=confhandler
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    
    self.pack(fill=BOTH)
    
    self.title = Label(self, text="Veuillez brancher une clé USB:", pady=16, bg=self.fond, font='Helvetica 16')
    self.title.grid(row=0, columnspan=4)

    self.message = Label(self, text="Le transfert démarrera dès qu'une clé aura été branchée", pady=8, bg=self.fond)
    self.message.grid(row=1, columnspan=4)
    
    self.imgUSBPlug=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/brancheClef.jpg")
    self.lblImgUSBPlug=Label(self, image=self.imgUSBPlug, pady=16)
    self.lblImgUSBPlug.grid(row=2, columnspan=4)
    
    if self.confhandler.hasFlavours:
      self.flavourChooser=FlavourChooser(self, self.confhandler, descwrap=70)
      self.flavourChooser.tkwidget.grid(row=4, column=0, columnspan=4, sticky="WE")
    else:
      Frame(self, height=20, bg=self.fond).grid(row=4, column=1) #V-Separator

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.quit, bg=glob_button_bg)
    self.bouton_quitter.grid(row=5, column=3, sticky=E, pady=6)  
    



class Interface_USBCopy(Frame):
  
  def __init__(self, fenetre, fileName, evtCancel):
    self.evtCancel=evtCancel
    self.fenetre=fenetre
    self.fond=glob_dialog_bg
    self.tickAnimStep=0
    self.tickDelay=400
    self.exited=False
    
    self.stats_mod = 101
    self.stats_speed = [0] * self.stats_mod
    self.stats_index = 0

    self.fileName=fileName
    
    Frame.__init__(self, fenetre, padx=glob_dialog_padx, pady=glob_dialog_pady, bg=self.fond)
    self.pack(fill=BOTH)
    
    self.message = Label(self, text="Envoi de "+self.fileName+" "+("."*(self.tickDelay%4)), pady=12, bg=self.fond, font='Helvetica 12')
    self.message.grid(row=0, columnspan=4)
    self.progress = ttk.Progressbar(self, orient="horizontal", length=400, mode="determinate", value=0)
    self.progress.grid(row=1, columnspan=4)

    Frame(self, height=24, bg=self.fond).grid(row=2, column=0) #V-Separator

    self.icone_bouton_quitter=ImageTk.PhotoImage(file = r"/usr/share/afrikalan/images/transfert/icone_bouton_fermer.png")
    self.bouton_quitter = Button(self, text="Annuler", image=self.icone_bouton_quitter, compound="left", command=self.btnQuit, bg=glob_button_bg)
    self.bouton_quitter.grid(row=3, column=3, sticky=E, pady=6)  
    
    self.fenetre.after(self.tickDelay, self.tickAnim)
  
  
  def btnQuit(self):
    self.evtCancel()

    
  def tickAnim(self):
    if self.exited:
      return(False)
    self.tickAnimStep+=1
    self.message.configure(text="Envoi de "+self.fileName+" "+("."*(self.tickDelay%4)))
    self.fenetre.after(self.tickDelay, self.tickAnim)


  def tmstr(self, t):
      days, rest = divmod(t, 86400)
      hours, rest = divmod(rest, 3600)
      minutes, seconds = divmod(rest, 60)
      return '{0:4d}:{1:02d}:{2:02d}'.format(int(days * 24 + hours),
              int(minutes), round(seconds))

  def updateProgr(self, pos, total, elapsed):
    if self.exited:
      return(False)
    elapsed_ = elapsed.total_seconds()
    self.stats_speed[self.stats_index % self.stats_mod] = pos / elapsed_
    self.stats_index = (self.stats_index + 1) % self.stats_mod
    self.progress.configure(value=pos, maximum=total)
    #out = '{0:12} {1:4.0%} {2:7.2f}{unit}B/s {3}'
    #unit = ('Mi', 1048576) if total > 999999 else ('ki', 1024)
    ## complete
    #if pos == total:
        #print(out.format(pos, pos / total, sum(self.stats_speed) / self.stats_mod / unit[1],
            #self.tmstr(elapsed_), unit=unit[0]))
    ## in progress
    #else:
        #print(out.format(pos, pos / total, sum(self.stats_speed) / self.stats_mod / unit[1],
            #self.tmstr((total - pos) / sum(self.stats_speed) * self.stats_mod), unit=unit[0]), end='')
        #print('\r')



#####################
# Threads
#####################

#
# Generic purposes threads
#

class ThreadGetFileFromHandler(threading.Thread):
  def __init__(self, fileId, handlerPath, paramsHandler, evtFinish):
    threading.Thread.__init__(self)
    self.fileId=fileId
    self.handlerPath=handlerPath
    self.paramsHandler=paramsHandler
    self.filePath=False
    self.evtFinish=evtFinish
    self.error=False
    
  def run(self):
    self.getFileProc=subprocess.Popen([self.handlerPath, "getFile", self.fileId]+self.paramsHandler, stdout=subprocess.PIPE)
    retCode=self.getFileProc.wait()
    if retCode!=0:
      #raise NameError("erreur du handler lors de l'obtention du fichier")
      print("erreur du handler lors de l'obtention du fichier")
      self.error=True
      self.evtFinish()
    else:
      ret, err=self.getFileProc.communicate()
      self.filePath=ret.decode().split("\n")[0]
    self.evtFinish()


#
# Threads involved in bluetooth tranfers
#

class MyBtDiscoverer(bluetooth.DeviceDiscoverer):
    def __init__(self, evtFound):
      self.evtFound=evtFound
      super().__init__()
    
    def pre_inquiry(self):
        self.done = False
    
    def device_discovered(self, mac, device_class, rssi, name):
        self.evtFound(mac, name)

    def inquiry_complete(self):
        self.done = True


class MyBtScanner:
  def __init__(self, evtUpdate):
    self.active=False
    self.arFound=[]
    self.evtUpdate=evtUpdate
    self.prm_initTtl=5
    self.prm_scanTime=8
    self.prm_scanTimeOut=15

  def evtFound(self, mac, name):
    
    alredayFound=False
    for i in range(len(self.arFound)):
      if self.arFound[i]['mac']==mac:
        self.arFound[i]['ttl']=self.prm_initTtl
        alredayFound=True
    
    if not alredayFound:
      self.arFound.append({"mac": mac, "name": name.decode(), "ttl": self.prm_initTtl})
    
    if self.active is True:
      self.evtUpdate(self.arFound)
  
  def stop(self):
    self.active=False
    self.btDisc.cancel_inquiry()
    print("STOPPED!")
    
  def evtCycleFinished(self):
    toRemove=[]
    
    for i in range(len(self.arFound)):
      self.arFound[i]['ttl']-=1
      if self.arFound[i]['ttl']<=0:
        toRemove.append(i)
    
    toRemove.reverse()
    for i in toRemove:
      self.arFound.pop(i)
    
    if self.active is True:
      self.evtUpdate(self.arFound)
  
  def processScan(self):
    self.btDisc = MyBtDiscoverer(self.evtFound)
    self.active=True
    
    while self.active:
      start_time = time.time()
      self.btDisc.find_devices(lookup_names = True, duration=self.prm_scanTime)

      readfiles = [ self.btDisc, ]

      while not self.btDisc.done:
          rfds = select.select( readfiles, [], [] )[0]
          if self.btDisc in rfds:
              self.btDisc.process_event()
          print("tick")
          pprint(time.time()-start_time)
      
          if (time.time()-start_time)>self.prm_scanTimeOut:
            print("timeout!! kill scan!!")
            self.btDisc.cancel_inquiry()
        
      self.evtCycleFinished()

class ThreadMajDests(threading.Thread):
  def __init__(self, cbMaj):
    threading.Thread.__init__(self)
    self.bts=MyBtScanner(cbMaj)

    
  def finish(self):
    self.bts.stop()
  
  def run(self):
    self.bts.processScan()


#Search and set channel with sdptool
class ThreadbtFindOPushChannel(threading.Thread):
  def __init__(self, targetMac, evtFinish):
    threading.Thread.__init__(self)
    self.targetMac=targetMac
    self.evtFinish=evtFinish
    self.foundChannel=False
    self.proc=False
    self.running=False
    
  def stop(self):
    if self.proc is not False and self.proc.poll() is None:
      self.running=False
      self.proc.kill()
      
    
  def run(self):
    self.running=True
    maxtries=8
    tries=maxtries
    retCode=255
    while retCode!=0 and self.running and tries!=0: #if called too early spdtool may fail, so we have to retry if that case...
      self.proc=subprocess.Popen(["sdptool", "search", "--bdaddr", self.targetMac, "OPUSH"], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
      ret, errs = self.proc.communicate()
      retCode=self.proc.returncode
      tries-=1
      if retCode!=0:
        print("spdtool failed retry ("+str(tries)+" left)")
        time.sleep(maxtries-tries)

    if retCode!=0:
      raise NameError('couldnt run sdptool to find channel') 
    
    arLineRet=ret.decode().split("\n")
    chan=-1
    for lineRet in arLineRet:
      txtChan, nbMatchChan=re.subn(".*Channel: ([0-9]*).*", "\g<1>", lineRet)
      if nbMatchChan==1: 
        self.foundChannel=int(txtChan)
      
    if self.foundChannel is False:
      raise NameError('couldnt find channel from sdptool output') 
    
    self.running=False
    self.evtFinish() #close the interface telling the use to wait

  
#send file over bluetooth
class ThreadBTSend(threading.Thread):
  def __init__(self, fileToSend, targetMac, targetChannel, evtStatusChange, updateProgr):
    threading.Thread.__init__(self)
    self.fileToSend=fileToSend
    self.targetMac=targetMac
    self.targetChannel=targetChannel
    self.status="NOT STARTED"
    self.evtStatusChange=evtStatusChange
    self.updateProgr=updateProgr
    self.active=True
    self.exitCode=None
    self.nbticks=0 #empiriquement: 1 tick = 4072 octets

  def cancel(self):
    self.active=False
    self.proc.kill()
    self.status="CANCELED"
    self.evtStatusChange()
  
  def run(self):
    self.status="WAIT ACCEPT"
    self.proc=subprocess.Popen(["obexftp", "--nopath", "--noconn", "--uuid", "none", "--timeout", "180", "--bluetooth", self.targetMac, "--channel", str(self.targetChannel), "--put", self.fileToSend], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    speedCalc=SpeedCalc()
    localFileSize=os.path.getsize(self.fileToSend)
    
    oret=''
    evtSendingSent=False
    while self.exitCode is None:
      ret=self.proc.stderr.read(1).decode()
      if ret=='\x08' and oret=="-" and not evtSendingSent: #pattern showing transfer started...
        self.status="SENDING"
        self.evtStatusChange()
        evtSendingSent=True #sécurité, pas nécéssaire normalement...
      
      if evtSendingSent and (ret=="-" or ret == "|" or ret == "/" or ret == "\\" ):
        self.nbticks+=1
        if self.nbticks%6==0:
          pos=self.nbticks*1024*16 #empiriquement: 1 tick = 1018 octets * 16 si mtu 16384
          speedCalc.record(pos)
          self.updateProgr(pos, localFileSize, kmgt(speedCalc.get())+"/s")

      oret=ret
      self.exitCode=self.proc.poll()
    
    print("finished, exit code="+str(self.exitCode)+" Ticks="+str(self.nbticks)+" localFileSize="+str(localFileSize))
    if self.status!="CANCELED":
      if self.exitCode==0 or self.exitCode==255:
          self.updateProgr(localFileSize, localFileSize, kmgt(speedCalc.get())+"/s")
          self.status="SUCCESS"
          self.evtStatusChange()
      else:
          self.status="FAILED"
          self.evtStatusChange()
    

#
# Threads involved in USB tranfers
#


class Thread_waitUsb(threading.Thread):
  def __init__(self, evtFinished):
    threading.Thread.__init__(self)
    self.evtFinished=evtFinished
    self.foundPath=False
    
  def run(self):
    self.active=True
    while self.active and self.foundPath is False:
      iterSearchUsb=glob.iglob("/media/USB*")
      self.foundPath=next(iterSearchUsb, False)
      time.sleep(0.7)
    
    self.evtFinished()

  def finish(self):
    self.active=False



#A great part of the code if this function comes from https://gist.github.com/monstermunchkin/2391716
class Thread_copyFile(threading.Thread):
  def __init__(self, srcFile, destFile, updateProgr, evtFinished):
    threading.Thread.__init__(self)
    self.srcFile=srcFile
    self.destFile=destFile
    self.evtFinished=evtFinished
    self.updateProgr=updateProgr
    self.success=False
    self.canceled=False
    self.error=False
    
  def cancel(self):
    self.canceled=True
    self.evtFinished()

  def run(self):
    blksize = 1048576 # 1MiB
    try:
      s = open(self.srcFile, 'rb')
      d = open(self.destFile, 'wb')
    except:
      if 's' in locals():
        s.close()
      if 'd' in locals():
        d.close()
      self.error=True
      self.evtFinished()
    else:
      try:
        total = os.stat(self.srcFile).st_size
        pos = 0
        start_elapsed = datetime.datetime.now()
        start_update = datetime.datetime.now()
        while not self.canceled and not self.error:
          buf = s.read(blksize)
          bytes_written = d.write(buf)
          end = datetime.datetime.now()
          pos += bytes_written
          diff = end - start_update
          if diff.total_seconds() >= 0.2:
            self.updateProgr(pos, total, end - start_elapsed)
            start_update = datetime.datetime.now()
          if bytes_written < len(buf) or bytes_written == 0:
            break
          os.sync()
      except:
        s.close()
        d.close()
        self.error=True
        self.evtFinished()
        #raise
      else:
        self.updateProgr(total, total, end - start_elapsed)
        s.close()
        d.close()
        self.success=True
        self.evtFinished()
    


##############################################
# Partie relative au pilotage de l'appli ... #
##############################################







#Allow dialog with transfer XML config, or dynamic handler as for web pages dump. 
class ConfHandler:
  def __init__(self, handlerPath, handlerArgs):
    self.handlerPath=handlerPath
    self.handlerArgs=handlerArgs
    self.selectedMode=False
    self.selectedFlavour=False
    self.hasFlavours=False
    
    self.transferHandler=afrikalan.transfer.handler.Handler(self.handlerPath, self.handlerArgs)
    self.handlerType=self.transferHandler.getType()    
    self.xmlRoot=self.transferHandler.xmlRoot
    
    rechFlavours=self.xmlRoot.xpath('/transfer/flavours/flavour')
    if(len(rechFlavours)>0):
      self.selectedFlavour=rechFlavours[0].attrib.get('id')
      self.hasFlavours=True


  def initForMode(self, mode):
    self.selectedMode=mode
    
    rechFlavourMode=self.xmlRoot.xpath('/transfer/flavours/flavour/default-for[@mode=\''+self.selectedMode+'\']')
    if(len(rechFlavourMode)>0):
      self.selectedFlavour=rechFlavourMode[0].getparent().attrib.get('id')


  def availableTransferModes(self):
    return(self.transferHandler.availableTransferModes())

  def appName(self):
    return(self.transferHandler.appName(default="cette application"))
  
  def getFilesSizes(self):
    ret=[]
    for fileXmlNode in self.getFilesToSend():
      filePath=fileXmlNode.attrib.get('path')
      if filePath is not None:
        ret.append(os.path.getsize(filePath))
    return(ret)
  
  def getFilesToSend(self):
    if self.hasFlavours is False:
      #self.confHandler.xmlRoot.iter("file")
      return(self.xmlRoot.xpath('/transfer/files/file'))
    else:
      ret=[]
      includesSelFlavour=self.xmlRoot.xpath('/transfer/flavours/flavour[@id=\''+self.selectedFlavour+'\']/include')
      if len(includesSelFlavour)==0:
        raise NameError('Selected Flavour not found in XML, or no files in it!!')
      for include in includesSelFlavour:
        fileid=str(include.attrib.get('file-id'))
        searchFileNode=self.xmlRoot.xpath('/transfer/files/file[@id=\''+fileid+'\']')
        if len(searchFileNode)==0:
          raise NameError('File id '+fileid+' not found in XML!!')
        ret.append(searchFileNode[0])
      return(ret)

  def getFlavoursData(self):
    searchFlavours=self.xmlRoot.xpath('/transfer/flavours/flavour')
    ret=[]
    for xmlNodeFlavour in searchFlavours:
      ret.append({'id': xmlNodeFlavour.attrib.get('id'), 'name': xmlNodeFlavour.attrib.get('name'), 'description': xmlNodeFlavour.attrib.get('description')})
    return(ret)
  
  def getSelectedFlavourData(self):
    searchSelFlavour=self.xmlRoot.xpath('/transfer/flavours/flavour[@id=\''+self.selectedFlavour+'\']')
    if len(searchSelFlavour)==0:
      raise NameError('Selected Flavour not found in XML!!')
    return({'id': searchSelFlavour[0].attrib.get('id'), 'name': searchSelFlavour[0].attrib.get('name'), 'description': searchSelFlavour[0].attrib.get('description')})
  
  def setSelectedFlavour(self, selectedFlavour):
    self.selectedFlavour=selectedFlavour


class Envoi:
  def __init__(self, confHandler):
    self.confHandler=confHandler
    self.error=False
    self.someSuccess=False
    self.errorDisplayed=False
    
  def processSendFiles(self):
    logger.falvour=confHandler.selectedFlavour
    logger.log("ENVOI DEMMARE")
    for fileXmlNode in self.confHandler.getFilesToSend():
      if not self.sendFile(fileXmlNode):
        logger.log("ENVOI ERREUR")
        if fileXmlNode.attrib.get('fail-continue', '0')!='1':
          self.error=True
          break
      else:
        self.someSuccess=True
    
    if not self.someSuccess:
      self.error=True
    
    if not self.error:
      logger.log("ENVOI FINI OK")
    self.finishedTransfer()
                          
  #TODO: passe filePath=appel classe confHandler
  def sendFile(self, fileXmlNode):
    fileId=fileXmlNode.attrib.get('id')
    if fileId is None:
      raise NameError("file tag without id")
    
    filePath=fileXmlNode.attrib.get('path')
      
    if filePath is None:
      if self.confHandler.handlerType=="static":
        raise NameError('no path given for static file!') 
      
      fileParams=[]
      for paramXmlNode in fileXmlNode.iter("param"):
        prm=paramXmlNode.attrib.get('value')
        if prm is None:
          raise NameError("Param tag without value")
        fileParams.append(prm)

      ifp=Interface_Patienter(root)
      tgf=ThreadGetFileFromHandler(fileId, self.confHandler.handlerPath, fileParams, evtFinish=ifp.quit)
      tgf.start()
      afrikalan.tkinter.center(root)
      ifp.mainloop()
      ifp.destroy()
      
      if tgf.error:
        return(False)
      
      filePath=tgf.filePath

    if not self.handleFileTransfer(filePath):
      return(False)
    
    if (fileXmlNode.attrib.get('delete-after')==1):
      os.unlink(filePath)
    
    return(True)




class EnvoiBT(Envoi):
  def __init__(self, confHandler):
    super().__init__(confHandler) 
    self.readyToSend=False
    self.etapeChoixDest()
  
  def etapeChoixDest(self):
    ifDestBT=Interface_destBlueTooth(root, self.confHandler)
    treadMajDests=ThreadMajDests(ifDestBT.majLbDests)
    treadMajDests.start()
    afrikalan.tkinter.center(root)
    ifDestBT.mainloop()
    print("exited ML ifDestBT")
    ifDestBT.destroy()
    treadMajDests.finish()
    if ifDestBT.choice is not False:
      self.evtTargetSelected(ifDestBT.choice, ifDestBT.choiceName)
    else:
      sys.exit(1)
    
  #Event: target bluetooth host 
  def evtTargetSelected(self, mac, name):
    self.targetMac=mac
    self.targetName=name
    ifp=Interface_Patienter(root)
    threadbtFindOPushChannel=ThreadbtFindOPushChannel(self.targetMac, evtFinish=ifp.quit)
    threadbtFindOPushChannel.start()
    afrikalan.tkinter.center(root)
    ifp.mainloop()
    ifp.destroy()
    if threadbtFindOPushChannel.foundChannel is False: #user canceled
      threadbtFindOPushChannel.stop()
      sys.exit(1) 
    self.targetChannel=threadbtFindOPushChannel.foundChannel
    print ("Mac cible: "+self.targetMac)
    print ("Canal cible: "+str(self.targetChannel))
    self.readyToSend=True
    self.processSendFiles()
    
  def updateProgr(self, *args):
    if hasattr(self.ifTransfertStatus, "updateProgr"):
      self.ifTransfertStatus.updateProgr(*args)
    
  def handleFileTransfer(self, filePath):
    print("Sending "+filePath)
    fileName=os.path.basename(filePath)
    threadBTSend=ThreadBTSend(fileToSend=filePath, targetMac=self.targetMac, targetChannel=self.targetChannel, evtStatusChange=self.evtFileTransfertStatusChange, updateProgr=self.updateProgr)
    threadBTSend.start()
    tranfertAccepted=False
    
    while True:
      if threadBTSend.status=="WAIT ACCEPT":
        self.ifTransfertStatus=Interface_blueToothWaitAccept(root, threadBTSend.cancel)
        afrikalan.tkinter.center(root)
        self.ifTransfertStatus.mainloop()
        self.ifTransfertStatus.destroy()
        self.ifTransfertStatus.exited=True
      elif threadBTSend.status=="SENDING":
        tranfertAccepted=True
        self.ifTransfertStatus=Interface_blueToothSending(root, fileName, threadBTSend.cancel)
        afrikalan.tkinter.center(root)
        self.ifTransfertStatus.mainloop()
        self.ifTransfertStatus.destroy()
        self.ifTransfertStatus.exited=True
      elif threadBTSend.status=="SUCCESS":
        return (True)
      elif threadBTSend.status=="FAILED":
        if threadBTSend.exitCode==67 or not tranfertAccepted:
          self.errorDisplayed=True
          messagebox.showerror(message="Vous n'avez pas accepté le tranfert sur votre téléphone. Le fichier n'a pas pu être envoyé...")
        else:
          self.errorDisplayed=True
          messagebox.showerror(message="Toutes nos excuses...\n\nLe transfert vers votre téléphone a échoué.")
        return (False)
      elif threadBTSend.status=="CANCELED":
        self.errorDisplayed=True
        messagebox.showwarning(message="Vous avez annulé le transfert")
        return (False)
      else:
        raise NameError("statut d'envoi bluettooth ["+str(threadBTSend.status)+"] inconnu!")


  def evtFileTransfertStatusChange(self):
    self.ifTransfertStatus.quit()

  def finishedTransfer(self):
    if not self.error:
      messagebox.showinfo(message="Le transfert vers votre téléphone a réussi.\n\nVous pouvez retrouver les fichiers tranférés dans le dossier \"bluetooth\" ou \"fichiers reçus\" de votre téléphone.")
    else:
      if not self.errorDisplayed:
        messagebox.showerror(message="Toutes nos excuses.\n Une erreur s'est produite...")
  
  
class EnvoiUSB(Envoi):
  def __init__(self, confHandler):
    super().__init__(confHandler) 
    self.readyToSend=False
    self.waitUsb()
  
  def waitUsb(self):
    self.ifWaitUsb=Interface_waitUsb(root, self.confHandler)
    thread_waitUsb=Thread_waitUsb(self.evtUsbInserted)
    thread_waitUsb.start()
    afrikalan.tkinter.center(root)
    self.ifWaitUsb.mainloop()
    print("exited ML ifWaitUsb")
    self.ifWaitUsb.destroy()
    thread_waitUsb.finish()
    if thread_waitUsb.foundPath is not False:
      self.doUsbTransfer(thread_waitUsb.foundPath)
    else:
      sys.exit(1)

  def evtUsbInserted(self):
    self.ifWaitUsb.quit()
    self.ifWaitUsb.update_idletasks() #else still wait until mouse mooved...

  def get_target_fs_type(self): #source: https://stackoverflow.com/questions/25283882/determining-the-filesystem-type-from-a-path-in-python
    import psutil #this is not needed anywhere else, and called in the few cases where a file exeed 4Gb limit
    root_type = ""
    for part in psutil.disk_partitions():
      if part.mountpoint == '/':
        root_type = part.fstype
        continue
      if self.targetPath.startswith(part.mountpoint):
        return part.fstype
    return root_type

  #check if destination is acutaly able to receive files.
  def checkDestination(self):
    sizes=self.confHandler.getFilesSizes()
    if len(sizes)==0:
      return(True) #nothing to check
    
    totalSize=sum(sizes)
    biggestFileSize=max(sizes)
    
    targetStats=statvfs = os.statvfs(self.targetPath)
    targetFreeSpace=targetStats.f_frsize * targetStats.f_bfree 
        
    if biggestFileSize>4000000000:
      targetFsType=self.get_target_fs_type()
      if targetFsType=="vfat":
        self.errorDisplayed=True
        messagebox.showerror(title="Espace insufisant", message="La clef insérée est formatée avec le système de fichier FAT 32. Cela ne permet pas le transfert des fichiers volumineux.\n\nSolution: Utilisez un disque externe, ou une autre clef USB.\nVous pouvez également formater de nouveau cette clé (Attention, toutes les données seront perdues):\n-Insérer la clef dans un ordinateur.\n-Faire un clic droit sur la clef et choisir \"formater\".\n-Dans \"système de fichier\", choisissez \"exFAT\" ou \"NTFS\".\n-Démarrez le formatage.")
        return(False)
      
    if totalSize>targetFreeSpace:
      self.errorDisplayed=True
      messagebox.showerror(title="Espace insufisant", message="La clef insérée ne dispose que de "+kmgt(targetFreeSpace)+" d'espace disponible.\nLes fichiers transférés necessitent "+kmgt(totalSize)+".\n\nSolution: Liberez de l'espace sur la clef, ou utilisez une clé de plus grande capacité...")
      return(False)
    
    if not os.access(self.targetPath, os.W_OK):
      self.errorDisplayed=True
      messagebox.showerror(title="Ecriture impossible", message="Il semble impossible d'écrire sur la clé que vous avez inséré.\n\nPeut être que la clef n'a pas été ejectée correctement. Vous pouvez tenter d'insérer la clef dans un ordinateur et de l'éjecter proprement.\n\nVous pouvez également tenter le transfert avec une clef.")
      return(False)
    return(True)
    
    
  #Event: usb key detected, setting up and starting transfer... 
  def doUsbTransfer(self, usbPath):
    self.targetPath=usbPath+"/afrikalan"
    try:
      if not os.path.exists(self.targetPath):
        os.makedirs(self.targetPath)
    except PermissionError:
      print("get pemission denied for mkdir, retrying once...")
      time.sleep(3) #maybe there was a "race" when umounting/remounting the key too quickly...
      if not os.path.exists(self.targetPath):
        os.makedirs(self.targetPath)

    if self.checkDestination():
      self.readyToSend=True
      self.processSendFiles()
    else:
      sys.exit(2)
    
  def evtFinish(self):
    self.ifCopy.quit()
    
  def handleFileTransfer(self, filePath):
    print("Sending "+filePath)
    fileName=os.path.basename(filePath)
    
    self.ifCopy=Interface_USBCopy(root, fileName, self.evtCancelCopy)
    self.threadSend=Thread_copyFile(srcFile=filePath, destFile=self.targetPath+"/"+fileName, updateProgr=self.ifCopy.updateProgr, evtFinished=self.evtFinish)
    self.threadSend.start()
    afrikalan.tkinter.center(root)
    if self.threadSend.error is False:
      self.ifCopy.mainloop()
    self.ifCopy.exited=True
    self.ifCopy.destroy()
    
    #pprint(vars(self.threadSend))
    
    if self.threadSend.success:
      return(True)
    elif self.threadSend.canceled:
      self.errorDisplayed=True
      messagebox.showwarning(message="Vous avez annulé le transfert")
      return(False)
    else:
      self.errorDisplayed=True
      messagebox.showerror(message="Toutes nos excuses.\n La copie vers le clé a échoué...")
      return(False)

  def evtCancelCopy(self):
    self.threadSend.cancel()


  def finishedTransfer(self):
    subprocess.check_output(['afrikalanMassStorEject'])
    if not self.error:
      messagebox.showinfo(message="Le(s) fichier(s) ont été copiés sur la clé USB.\n\nLorsque vous insererez la clé USB dans un ordinateur, vous retrouverez ces fichiers dans le dossier \"Afrikalan\" qui se trouve sur la clé.\n\nLa clé USB a été ejectée.\nVous pouvez maintenant retirer la clé USB en toute sécurité.")
    else:
      if not self.errorDisplayed:
        messagebox.showerror(message="Toutes nos excuses.\n Une erreur s'est produite...")
      messagebox.showinfo(message="La clé USB a été ejectée.\nVous pouvez maintenant retirer la clé USB en toute sécurité.")

  
def parseArgs():
  argparser=argparse.ArgumentParser(description='Transfert d\'applications afrikalan')
  argparser.add_argument("handlerPath", help="chemin vers un fichier XML (ou un programme générant du XML) permetant la prise en charge du transfert de l'application ou du document choisi")
  argparser.add_argument("--media", choices=["BT", "USB"], help="préselectionner la media à utiliser pour le trasfert. valeurs acceptées: BT ou USB", default=False)
  argparser.add_argument("--from", dest="callfrom", help="application ayant initié le transfert (utile pour les stats)", default="N/A")
  return(argparser.parse_args())
  
class Logger():
  def __init__(self, handler='NA', callfrom="NA"):
    self.handler=handler
    self.callfrom=callfrom
    self.media=False
    self.falvour=False
    self.spaceStart()
    
  def spaceStart(self):
    logfile=open("/rw/transfers.log", "a")
    logfile.write("\n\n")
    logfile.close()
    
  def log(self, event):
    logstr='('+self.callfrom+')'
    if self.media is not False:
      logstr+='{'+self.media+'}'

    logstr+=self.handler
    
    if self.falvour is not False:
      logstr+='['+self.falvour+']'
    
    logstr+=' ### '+event
    
    logfile=open("/rw/transfers.log", "a")
    logfile.write(logstr+'\n')
    logfile.close()
    
  
  
#######################
# Main part
#######################

def affErr(exctype, value, tb):
  messagebox.showerror(message="Toutes nos excuses, une erreur s'est produite:\n\n"+str(value))
#sys.excepthook = affErr
threading.excepthook=affErr #ne marche pas :-/

# On démarre la boucle Tkinter qui s'interompt quand on ferme la fenêtre




args=parseArgs()
    
handlerArgs=[] #TODO pouvoir lire ça depuis ligne de commande ou supprimer...


confHandler=ConfHandler(args.handlerPath, handlerArgs)

logger=Logger(handler=args.handlerPath, callfrom=args.callfrom)
logger.log("DEBUT")


root=Tk()
root.attributes('-topmost', True)
root.title('Transfert d\'applications ou de documents')


media=args.media
if media is False:
  ifChoixMethode = Interface_choixMethode(root, confHandler.availableTransferModes(), confHandler.appName())
  afrikalan.tkinter.center(root)
  ifChoixMethode.mainloop()
  ifChoixMethode.destroy()
  print("exited ML ifChoixMethode")
  media=ifChoixMethode.choice
  
if media is not False:
  logger.media=media
  logger.log("MEDIA CHOISI")
  confHandler.initForMode(media)
  if (media=='BT'):
    envoi=EnvoiBT(confHandler)
  if (media=='USB'):
    envoi=EnvoiUSB(confHandler)
  if (media=='WIFI'):
    subprocess.Popen(['afrikalanAffMan.py', '/usr/share/doc/afrikalan/guides/telechWifi/telechWifi.xml'])

