#!/usr/bin/python3

#TODO check https://weasyprint.readthedocs.io

import sys, os
import afrikalan.transfer.getEmbed
import afrikalan.web
from contextlib import redirect_stdout

from lxml import html
import urllib
import re

def genXmlFiles():
  url=afrikalan.web.getViewedURL()
  
  ret="""<?xml version="1.0" encoding="UTF-8" ?>
  <transfer>
    <modes usb='1' bluetooth='1' />
    <eltname>cette page</eltname>
    <files>
      <file id='pageHTML' delete-after='1'>
        <param value='"""+url+"""' />
      </file>
      <file id='pageHTMLNoPic' delete-after='1'>
        <param value='"""+url+"""' />
      </file>
      <file id='pdf' delete-after='1' fail-continue='1'>
        <param value='"""+url+"""' />
      </file>
    </files>
    <flavours>
      <flavour id='pagehtml' name='HTML avec images intégrées' description='fonctionne sur tous les appareils ou presque, version complète avec images'>
        <default-for mode='BT' />
        <include file-id='pageHTML' />
      </flavour>
      <flavour id='pagehtmlnopic' name='HTML sans images' description='Plus léger que la version avec images. Fonctionne sur tous les appareils'>
        <include file-id='pageHTMLNoPic' />
      </flavour>
      <flavour id='pdf' name='PDF' description='Idéal pour les impressions. Ne fonctionne que sur ordinateur équipé d&apos;un logiciel de lecture PDF'>
        <include file-id='pdf' />
      </flavour>
      <flavour id='htmlpdf' name='PDF + HTML' description='Le document sera transféré en HTML et en PDF. Cela garantit qu&apos;il  sera lisible sur tout type d&apos;ordinateur.'>
        <default-for mode='USB' />
        <include file-id='pdf' />
        <include file-id='pageHTML' />
      </flavour>
    </flavours>
  </transfer>"""
  
  return(ret)

def handleGetPageHtml(url, pic=True):
  tmpFolder="/tmp/embededPages"
  if not os.path.exists(tmpFolder):
    os.makedirs(tmpFolder)

  with redirect_stdout(sys.stderr):
    print("a")
    print("b")
    objEmbedoc=afrikalan.transfer.getEmbed.Embedoc(url)
    
    if pic:
      objEmbedoc.embedImages()
    else:
      objEmbedoc.removeImages(wikiContainerRemove=True)
    
    objEmbedoc.embedCss()
    objEmbedoc.correctLinks()
    objEmbedoc.removeBase()
    objEmbedoc.removeKiwixBar()
    filePath=tmpFolder+"/"+objEmbedoc.filename()
    objEmbedoc.save(filePath)

  print(filePath)


def cleanForPdkKit(objEmbedoc, url):
    xmlRoot=objEmbedoc.getXmlRoot()
  
    for node in xmlRoot.xpath(".//script"):
      node.getparent().remove(node)
      
    for node in xmlRoot.xpath(".//link"):
      if "mediawiki.skinning.content.parsoid.css" in node.attrib.get('href'):
        print ("patch "+node.attrib.get('href'))
        content=re.sub(r'url\([^\)]*\)', 'none', objEmbedoc.fetchUrl(objEmbedoc.absUrl(node.attrib.get('href'))).decode('utf-8'))
        
        headNode=xmlRoot.find("./head")
        newNode=html.Element("style")
        newNode.attrib["type"]="text/css"
        newNode.text=content
        headNode.append(newNode)
        node.getparent().remove(node)


    
    #patchBase
    headNode=xmlRoot.find("./head")
    baseNode=html.Element("base")
    baseNode.attrib["href"]=url
    headNode.insert(0, baseNode)
    
    for elt in xmlRoot.xpath(".//details"):
      elt.tag="div"
      
    for img in xmlRoot.xpath(".//img"):
      img.attrib["src"]=urllib.parse.urljoin(url, img.attrib["src"])
      print(img.attrib.get("src", "--------------------"))




def handleGetPagePdf(url):
  tmpFolder="/tmp/embededPages"
  if not os.path.exists(tmpFolder):
    os.makedirs(tmpFolder)

  import pdfkit
  with redirect_stdout(sys.stderr):
    objEmbedoc=afrikalan.transfer.getEmbed.Embedoc(url)
    filePath=tmpFolder+"/"+objEmbedoc.filename(ext=False)+".pdf"
    objEmbedoc.correctLinks()
    objEmbedoc.removeKiwixBar()
    #objEmbedoc.embedCss()
    #objEmbedoc.embedJs()
    
    xmlRoot=objEmbedoc.getXmlRoot()
    cleanForPdkKit(objEmbedoc, url)
    
    options={"load-media-error-handling": "skip", "load-error-handling": "skip", "disable-javascript": None}

    pdfkit.from_string(html.tostring(xmlRoot).decode("utf8"), filePath, options=options)
  print(filePath)



action=sys.argv[1]

if action=="listFiles":
  print(genXmlFiles())

if action=="getFile":
  mode=sys.argv[2]
  url=sys.argv[3]
  
  if mode=='pageHTML':
    handleGetPageHtml(url, pic=True)
  elif mode=='pageHTMLNoPic':
    handleGetPageHtml(url, pic=False)
  elif mode=='pdf':
    handleGetPagePdf(url)
  else:
    print("mode document inconnu")

