#!/bin/bash

if [ "$1" != "lanceLock" ]; then
flock -no ~/afrikalanAppliOuverte.lock $0 "lanceLock" "$@"
exit 0
else
shift
fi

. afrikalanLireResol.sh
. /etc/afrikalan.conf

if [ "$afrikalan_desktop_mode" != "kiosque" ]; then
  killall lxpanel
  afrikalanCacheBureau.sh 1
fi


setxkbmap us

ls -l /dev/input/by-path/*-kbd
if [ $? -eq 0 ] && [ $overscanGauche -eq 0 ] && [ $overscanDroite -eq 0 ] && [ $overscanHaut -eq 0 ] && [ $overscanBas -eq 0 ]; then
  numlockx on
  tuxmath --autolevel $@ >>/rw/logTm 2>&1
  setxkbmap fr
  if [ "$afrikalan_desktop_mode" != "kiosque" ]; then
    lxpanel&
    afrikalanCacheBureau.sh 0
  fi
exit
fi

appAfrikalanRedim () {
wmctrl -r "Tux" -e "0,$positionFenetreX,$positionFenetreY,650,492"
}

attenteFenetre () {

wmctrl -l | grep "Tux"
while [ $? -ne 0 ]
do
sleep 1s
wmctrl -l | grep "Tux"
done
echo "Tux math trouvé"
}

attenteXephyr () {

wmctrl -l | grep "Xephyr"
while [ $? -ne 0 ]
do
echo rech xephyr...
sleep 1s
wmctrl -l | grep "Xephyr"
done
echo "Xephyr trouvé"
}

attenteClavier () {

wmctrl -l | grep "Clavier virtuel (xvkbd)"
while [ $? -ne 0 ]
do
sleep 1s
wmctrl -l | grep "Clavier virtuel (xvkbd)"
done
echo "xvkbd trouvé"
}

cat /usr/share/afrikalan/clavier/.XressourcesXvkbd | xrdb
xvkbd -no-function -keypad &
attenteClavier
wmctrl -r "Clavier virtuel (xvkbd)" -b "add,below"


numlockx on

if [ $RESX -gt 700 ] || [ $RESY -gt 500 ]; then
	Xephyr -screen $RESX"x"$RESY :1&
	attenteXephyr
	wmctrl -r "Xephyr" -N "Tux, of Math Command"
	OLD_DISPLAY=$DISPLAY
	DISPLAY=:1
	tuxmath --autolevel $@ >>/rw/logTm 2>&1 &
	pidAppli=$!
	DISPLAY=$OLD_DISPLAY
	positionFenetreX=$overscanGauche
	positionFenetreY=$(echo "$overscanHaut - 23" | bc)
else
	tuxmath --windowed --autolevel $@ >>/rw/logTm 2>&1 &
	pidAppli=$!
	positionFenetreX=$(echo "( $RESX - 644 ) / 2 + $overscanGauche" | bc)
	positionFenetreY=$(echo "$RESY - 510 + $overscanHaut" | bc)
fi

attenteFenetre
appAfrikalanRedim





positionX=0
positionY=0

tailleClavierX=140
tailleClavierY=200
montreClavierX=45
montreClavierY=$(echo "310 + $overscanHaut" | bc)
positionClavierX=$(echo "( $RESX - $tailleClavierX ) / 2 + $overscanGauche" | bc)
positionClavierY=$overscanHaut


function deplacer {
	wmctrl -r "Clavier virtuel (xvkbd)" -e "0,$positionClavierX,$positionClavierY,$tailleClavierX,$tailleClavierY"
	wmctrl -r "Clavier virtuel (xvkbd)" -b "add,above"
	wmctrl -a "Tux, of Math Command"
}

while $(kill -s 0 $pidAppli)
do
	eval $(xdotool getmouselocation --shell)


        if [ $Y -lt $montreClavierX ] && [ $positionY -ne -1 ]; then
                positionY=-1
                positionFenetreY=$overscanHaut
                deplacer
        fi

        if  [ $Y -gt $montreClavierY ] && [ $positionY -eq -1 ]; then
                positionY=0
                wmctrl -r "Clavier virtuel (xvkbd)" -b "add,below"
        fi
#         if  [ $X -lt 210 ] || [ $X -gt 410 ] && [ $Y -gt 15 ] && [ $positionY -eq -1 ]; then
#                 positionY=0
#                 wmctrl -r "Clavier virtuel (xvkbd)" -b "add,below"
#         fi
	sleep 0.25s
	
done

killall xvkbd
killall Xephyr

if [ "$afrikalan_desktop_mode" != "kiosque" ]; then
  lxpanel&
  afrikalanCacheBureau.sh 0
fi

setxkbmap fr
