#!/bin/bash

if [ "$1" != "lanceLock" ]; then
flock -no ~/afrikalanAppliOuverte.lock $0 "lanceLock" "$@"
exit 0
else
shift
fi

. afrikalanLireResol.sh
. /etc/afrikalan.conf


if [ "$afrikalan_desktop_mode" != "kiosque" ]; then
  afrikalanCacheBureau.sh 1
  killall lxpanel
fi

if [ $RESX -ge 800 ] && [ $RESY -ge 480 ]; then
	tuxpaint --fullscreen yes --native
	if [ "$afrikalan_desktop_mode" != "kiosque" ]; then
    afrikalanCacheBureau.sh 0
    lxpanel&
  fi
	exit
fi

tuxpaint&
pidTuxPaint=$!

positionX=0
positionY=0

positionFenetreXgauche=$(echo 8 + $overscanGauche | bc)
positionFenetreXcentre=$(echo "( $RESX - 810 ) / 2 + $overscanGauche" | bc)
positionFenetreXdroite=$(echo $RESX - 810 + $overscanGauche | bc)

positionFenetreYhaut=-$(echo 20 + $overscanHaut | bc)
positionFenetreYcentre=$(echo "($RESY-600)/2  + $overscanHaut" | bc)
positionFenetreYbas=$(echo $RESY - 550  + $overscanHaut | bc)


positionFenetreX=$positionFenetreXcentre
positionFenetreY=$positionFenetreYcentre
oposX=$positionFenetreX;
oposY=$positionFenetreY;



deplacerX=0;
deplacerY=0;
deplacer=1;
if [ $RESX -lt 800 ]; then deplacerX=1; fi
if [ $RESY -lt 480 ]; then deplacerY=1; fi
if [ $deplacerX -eq 0 ] && [ $deplacerY -eq 0 ]; then deplacer=0; fi


function deplacer {
	wmctrl -r "Tux Paint" -e "0,$positionFenetreX,$positionFenetreY,800,600"
	sleep 0.5s
	wmctrl -r "Tux Paint" -e "0,$positionFenetreX,$positionFenetreY,800,600"
#	xwit -root -rwarp $(echo "( ( $positionFenetreX - $oposX ) *3 ) / 4" | bc) $(echo "( ( $positionFenetreY - $oposY ) *3 ) / 4" | bc)
	oposX=$positionFenetreX;
	oposY=$positionFenetreY;
}

eval $(afrikalanLireResol.sh )

posXDeclencheDroite=$(echo $RESX + $overscanGauche - 6 | bc)
posXRetourDroite=$(echo $RESX - 151 + $overscanGauche | bc)
posXDeclencheGauche=$(echo $overscanGauche + 10 | bc)
posXRetourGauche=$(echo $overscanGauche + 130 | bc)

echo "$posXDeclencheDroite / $posXRetourDroite"

posXDeclencheBas=$(echo $RESY - 6 + $overscanHaut | bc)
posXRetourBas=$(echo $RESY - 76  + $overscanHaut| bc)
posXDeclencheHaut=$(echo 5 + $overscanHaut | bc)
posXRetourHaut=$(echo 80  + $overscanHaut | bc)



if [ $deplacer -eq 1 ]; then
	while $(kill -s 0 $pidTuxPaint)
	do
		eval $(xdotool getmouselocation --shell)


		if [ $deplacerX -eq 1 ] && [ $X -lt $posXDeclencheGauche ] && [ $positionX -ne -1 ]; then
			positionX=-1
			positionFenetreX=$positionFenetreXgauche
			deplacer
		fi
		if [ $deplacerX -eq 1 ] && [ $X -gt $posXDeclencheDroite ] && [ $positionX -ne 1 ]; then
			positionX=1
			positionFenetreX=$positionFenetreXdroite
			deplacer
		fi
		if [ $deplacerX -eq 1 ] && [ $X -gt $posXRetourGauche ] && [ $X -lt $posXRetourDroite ] && [ $positionX -ne 0 ]; then
			positionX=0
			positionFenetreX=$positionFenetreXcentre
			deplacer
		fi


		if [ $deplacerY -eq 1 ] && [ $Y -lt $posXDeclencheHaut ] && [ $positionY -ne -1 ]; then
			positionY=-1
			positionFenetreY=-20
			deplacer
		fi
		if [ $deplacerY -eq 1 ] && [ $Y -gt $posXDeclencheBas ] && [ $positionY -ne 1 ]; then
			positionY=1
			positionFenetreY=$positionFenetreYbas
			deplacer
		fi
		if [ $deplacerY -eq 1 ] && [ $Y -gt $posXRetourHaut ] && [ $Y -lt $posXRetourBas ] && [ $positionY -ne 0 ]; then
			positionY=0
			positionFenetreY=$positionFenetreYcentre
			deplacer
		fi
		sleep 0.35s
		
	done
else
	while $(kill -s 0 $pidTuxPaint)
	do
		sleep 1s
	done
fi


if [ "$afrikalan_desktop_mode" != "kiosque" ]; then
  lxpanel&
  afrikalanCacheBureau.sh 0
fi


