#!/bin/python3

import Xlib
import Xlib.display
from Xlib.error import XError

class Scanner:

  def __init__(self):
    self.evtFound=False #To be overwirten by caller
    self.regexSearch=False
    self.partSearch=False
    self.maxScanWinDepth=3
    self.display = Xlib.display.Display()
    self.NET_WM_NAME = self.display.intern_atom('_NET_WM_NAME')
    self.root = self.display.screen().root

  def scanWins(self):
    self.winIdList=[]
    self.winTitleList=[]
    self.foundWinId=False
    self.foundWinTitle=False

    return (self.scanWinsTree(self.root, 0))
  
  def scanWinsTree(self, window, depth):
    winName=""
    try:
      if window.get_wm_class() is not None:
        winName=str(window.get_full_property(self.NET_WM_NAME, 0).value)
    except:
      pass
    winId=window.__resource__()
    self.winIdList.append(winId)
    self.winTitleList.append(winName)

    if (self.regexSearch is not False and self.regexSearch.match(winName)) or (self.partSearch is not False and self.partSearch in winName):
      self.foundWinId=winId
      self.foundWinTitle=winName
      if self.evtFound is not False:
        self.evtFound(winId)
      return (True)

    
    if depth<self.maxScanWinDepth:
      children=[]
      try:
        children = window.query_tree().children
      except XError:
        pass
      for child in children:
        if self.scanWinsTree(child, depth+1):
          return(True)


